using System;
using System.Runtime.InteropServices;
using System.Drawing;

namespace NHikPlayer
{
	#region Struct
	/// <summary>
	/// typedef struct{
	///		long nWidth;	//λءƵΪ 0
	///		long nHeight;	//ߡƵΪ 0
	///		long nStamp;	//ʱϢλ롣
	///		long nType;		//ͣT_AUDIO16T_RGB32 T_YV12궨˵
	///		long nFrameRate;//ʱͼ֡ʡ
	/// }FRAME_INFO; 
	/// </summary>
	public struct FRAME_INFO
	{
		/// <summary>
		/// λءƵΪ0
		/// 
		/// long nWidth;
		/// </summary>
		public int nWidth;
		/// <summary>
		/// ߡƵΪ0
		/// 
		/// long nHeight;
		/// </summary>
		public int nHeight;
		/// <summary>
		/// ʱϢλ
		/// 
		/// long nStamp;
		/// </summary>
		public int nStamp;
		/// <summary>
		/// ͣT_AUDIO16T_RGB32 T_YV12
		/// 
		/// long nType;
		/// </summary>
		public int nType;
		/// <summary>
		/// ʱͼ֡
		/// 
		/// long nFrameRate;
		/// </summary>
		public int nFrameRate;
	}

	/// <summary>
	/// typedef struct{
	///		long nFilePos;	//ļλã
	///		long nFrameNum;	//֡ţ
	///		long nFrameTime;//֡ʱ꣨ms;
	/// }FRAME_POS,*PFRAME_POS; 
	/// </summary>
	public struct PFRAME_POS
	{
		/// <summary>
		/// ļλ
		/// 
		/// long nFilePos;
		/// </summary>
		public int nFilePos;
		/// <summary>
		/// ֡
		/// 
		/// long nFrameNum;
		/// </summary>
		public int nFrameNum;
		/// <summary>
		/// ʱ䣨Դļʼʱ䣩
		/// 
		/// long nFrameTime;
		/// </summary>
		public int nFrameTime;
		/// <summary>
		/// ʱ֡
		/// 
		/// long nErrorFrameNum;
		/// </summary>
		public int nErrorFrameNum;
		/// <summary>
		/// ľʱ䣨豸¼ļã
		/// 
		/// SYSTEMTIME *pErrorTime;
		/// </summary>
		public DateTime pErrorTime;
		/// <summary>
		/// ʱʧ֡
		/// 
		/// long nErrorLostFrameNum;
		/// </summary>
		public int nErrorLostFrameNum;
		/// <summary>
		///  ʱݴС
		/// 
		/// long nErrorFrameSize;
		/// </summary>
		public int nErrorFrameSize;
	}

	/// <summary>
	/// typedef struct{
	///		char *pDataBuf;	//֡׵ַ
	///		long nSize;		//֡ĴС
	///		long nFrameNum;	//֡ĸ
	///		BOOL bIsAudio;	//ǷƵ֡
	///		long nReserved;	//
	/// }FRAME_TYPE; 
	/// </summary>
	public struct FRAME_TYPE
	{
		/// <summary>
		/// ֡׵ַ
		/// 
		/// char *pDataBuf;
		/// </summary>
		public byte[] pDataBuf;
		/// <summary>
		/// ֡ĴС
		/// long nSize;
		/// </summary>
		public int nSize;
		/// <summary>
		/// ֡ĸ
		/// 
		/// long nFrameNum;
		/// </summary>
		public int nFrameNum;
		/// <summary>
		/// ǷƵ֡
		/// 
		/// BOOL bIsAudio;
		/// </summary>
		public bool bIsAudio;
		/// <summary>
		/// 
		/// 
		/// long nReserved;
		/// </summary>
		public int nReserved;
	}

	#endregion

	#region Delegate
	///////////////////////////////////////////////////////////////////////////////////////////////
	//ע⣺ڻصΪvbֶ֧̣߳ԵصVBĺʱvc߳еvbĺ⡣
	//		Microsoft Knowledge Base Article - Q198607 PRB: Access Violation in VB Run-Time Using AddressOf  
	///////////////////////////////////////////////////////////////////////////////////////////////

	/// <summary>
	/// void (CALLBACK* DecCBFun)(long nPort,char * pBuf,long nSize,FRAME_INFO * pFrameInfo, long nReserved1,long nReserved2)
	/// صָ롣Ϊ NULL; 
	/// </summary>
	/// <param name="nPort">ͨ</param>
	/// <param name="pBuf">Ƶ</param>
	/// <param name="nSize">ƵpBufĳ</param>
	/// <param name="pFrameInfo">ͼϢ</param>
	/// <param name="nReserved1"></param>
	/// <param name="nReserved2"></param>
	public delegate void DecCBFun(int nPort, IntPtr pBuf, int nSize, ref FRAME_INFO pFrameInfo, int nReserved1, int nReserved2);

	/// <summary>
	/// void (CALLBACK* DisplayCBFun)(long nPort,char * pBuf,long nSize,long nWidth,long nHeight,long nStamp,long nType,long nReceaved)); 
	/// ץͼصΪ NULL; 
	/// </summary>
	/// <param name="nPort">ͨ</param>
	/// <param name="pBuf">ͼ</param>
	/// <param name="nSize">ͼݴС</param>
	/// <param name="nWidth">λ</param>
	/// <param name="nHeight"></param>
	/// <param name="nStamp">ʱϢλ</param>
	/// <param name="nType">ͣT_YV12T_RGB32T_UYVY</param>
	/// <param name="nReceaved"></param>
	public delegate void DisplayCBFun(int nPort, IntPtr pBuf, int nSize, int nWidth, int nHeight, int nStamp, int nType, int nReceaved);

	/// <summary>
	/// void CALLBACK SourceBufCallBack(long nPort,DWORD nBufSize, DWORD dwUser,void*pContext) 
	/// </summary>
	/// <param name="nPort">ͨ</param>
	/// <param name="nBufSize">ʣ</param>
	/// <param name="dwUser">û</param>
	/// <param name="pContext"></param>
	public delegate void SourceBufCallBack(int nPort, ushort nBufSize, ushort dwUser, IntPtr pContext);

	/// <summary>
	/// void FileRefDone(DWORD nPort,DWORD nUser) 
	/// </summary>
	/// <param name="nPort">ͨ</param>
	/// <param name="nUser">û</param>
	public delegate void FileRefDone(int nPort, ushort nUser);

	/// <summary>
	/// void CALLBACK DrawFun(long nPort,HDC hDc,LONG nUser) 
	/// </summary>
	/// <param name="nPort">ͨ</param>
	/// <param name="hDc">hDc OffScreen豸ģʾڿͻDC</param>
	/// <param name="nUser">ûݣû</param>
	public delegate void DrawFun(int nPort, IntPtr hDc, int nUser);

	/// <summary>
	/// void __stdcall Verify(long nPort, FRAME_POS * pFilePos, DWORD bIsVideo, DWORD nUser)
	/// </summary>
	/// <param name="nPort">ͨ</param>
	/// <param name="pFilePos">ļλ</param>
	/// <param name="bIsVideo">ǷƵݣ1Ƶ0Ƶ</param>
	/// <param name="nUser">û</param>
	public delegate void Verify(int nPort, ref PFRAME_POS pFilePos, ushort bIsVideo, ushort nUser);

	/// <summary>
	/// void __stdcall  Audio(long nPort, char * pAudioBuf, long nSize, long nStamp, long nType, long nUser) 
	/// </summary>
	/// <param name="nPort">ͨ</param>
	/// <param name="pAudioBuf">waveʽƵ</param>
	/// <param name="nSize">Ƶݳ</param>
	/// <param name="nStamp"> ʱ(ms) </param>
	/// <param name="nType">ƵT_AUDIO16, 16khzÿ16λʾ </param>
	/// <param name="nUser">ûԶ</param>
	public delegate void Audio(int nPort, string pAudioBuf, int nSize, int nStamp, int nType, int nUser);

	/// <summary>
	/// void (CALLBACK *funEncChange)(long nPort,long nUser) 
	/// </summary>
	/// <param name="nPort">ͨ</param>
	/// <param name="nUser">ûԶ</param>
	public delegate void EncChange(int nPort, int nUser);

	/// <summary>
	/// void(CALLBACK *funGetOrignalFrame)(long nPort,FRAME_TYPE *frameType, long nUser) 
	/// </summary>
	/// <param name="nPort">ͨ</param>
	/// <param name="frameType">й֡Ϣ</param>
	/// <param name="nUser"></param>
	public delegate void GetOrignalFrame(int nPort, ref FRAME_TYPE frameType, int nUser);

	#endregion

	/// <summary>
	/// 
	/// </summary>
	public sealed class HikPlayer
	{
		#region Const Member Variables
        // #define WINVER 
        // 0x0700 Windows 7
        // 0x0600 Windows Vista
        // 0x0502 Windows 2003 Server
        // 0x0410 Windows XP
        //<0x0400 Windows 98/Windows 2000
        public static readonly int WINVER = 0x0502;

		public static readonly uint WM_USER = 0x0400;
		public static readonly uint WM_FILE_END = WM_USER + 33;
		public static readonly uint WM_ENC_CHANGE = WM_USER + 100;
		
        public static readonly int COLOR_DEFAULT = 64;
        public static readonly int PLAYER_SLIDER_MAX = 200;
        public static readonly int MAX_DISPLAY_DEVICE = 4;

        public static readonly int WIDTH_PAL = 352;
        public static readonly int HEIGHT_PAL = 288;

		#region Source buffer
		//#define SOURCE_BUF_MAX
		public static readonly uint SOURCE_BUF_MAX = 1024 * 100000;
		//#define SOURCE_BUF_MIN    1024*50
		public static readonly uint SOURCE_BUF_MIN = 1024 * 50;
		#endregion

		#region Frame type
		/// <summary>
		/// Ƶ;16khzÿ16λʾ
		/// </summary>
		public static readonly int T_AUDIO16 = 101;
		public static readonly int T_AUDIO8 = 100;

		/// <summary>
		/// ƵݣuyvyʽU0-Y0-V0-Y1-U2-Y2-V2-Y3.һλͼϽǡ 
		/// </summary>
		public static readonly int T_UYVY = 1;
		/// <summary>
		/// Ƶݣyv12ʽ˳Y0-Y1-V0-V1.U0-U1-.. 
		/// </summary>
		public static readonly int T_YV12 = 3;
		/// <summary>
		/// Ƶݡÿ4ֽڣзʽλͼƣB-G-R-0 һλͼ½ǡ 
		/// </summary>
		public static readonly int T_RGB32 = 7;
		#endregion

		#region Stream type
		/// <summary>
		/// ʵʱģʽʺϲʵʱݣ̽롣
		/// </summary>
		public static readonly int STREAME_REALTIME = 0;
		/// <summary>
		/// ļģʽʺûļʽ롣
		/// ע⣺Hik_PlayM4_InputData()FALSEʱûҪһ롣
		/// </summary>
		public static readonly int STREAME_FILE = 1;
		#endregion

		#region Error code
		/// <summary>
		/// ûд
		/// no error
		/// </summary>
		public static readonly int HIK_PLAYM4_NOERROR = 0;
		/// <summary>
		/// Ƿ
		/// input parameter is invalid;
		/// </summary>
		public static readonly int HIK_PLAYM4_PARA_OVER = 1;
		/// <summary>
		/// ˳򲻶
		/// The order of the function to be called is error.
		/// </summary>
		public static readonly int HIK_PLAYM4_ORDER_ERROR = 2;
		/// <summary>
		/// ýʱʧ
		/// Create multimedia clock failed;
		/// </summary>
		public static readonly int HIK_PLAYM4_TIMER_ERROR = 3;
		/// <summary>
		/// Ƶʧ
		/// Decode video data failed.
		/// </summary>
		public static readonly int HIK_PLAYM4_DEC_VIDEO_ERROR = 4;
		/// <summary>
		/// Ƶʧ
		/// Decode audio data failed.
		/// </summary>
		public static readonly int HIK_PLAYM4_DEC_AUDIO_ERROR = 5;
		/// <summary>
		/// ڴʧ
		/// Allocate memory failed.
		/// </summary>
		public static readonly int HIK_PLAYM4_ALLOC_MEMORY_ERROR = 6;
		/// <summary>
		/// ļʧ
		/// Open the file failed.
		/// </summary>
		public static readonly int HIK_PLAYM4_OPEN_FILE_ERROR = 7;
		/// <summary>
		/// ߳¼ʧ
		/// Create thread or event failed.
		/// </summary>
		public static readonly int HIK_PLAYM4_CREATE_OBJ_ERROR = 8;
		/// <summary>
		/// DirectDrawʧ
		/// Create DirectDraw object failed.
		/// </summary>
		public static readonly int HIK_PLAYM4_CREATE_DDRAW_ERROR = 9;
		/// <summary>
		/// ˻ʧ
		/// Failed when creating off-screen surface.
		/// </summary>
		public static readonly int HIK_PLAYM4_CREATE_OFFSCREEN_ERROR = 10;
		/// <summary>
		/// ʧ
		/// Buffer is overflow.
		/// </summary>
		public static readonly int HIK_PLAYM4_BUF_OVER = 11;
		/// <summary>
		/// Ƶ豸ʧ
		/// Failed when creating audio device.
		/// </summary>
		public static readonly int HIK_PLAYM4_CREATE_SOUND_ERROR = 12;
		/// <summary>
		/// ʧ
		/// Set volume failed.
		/// </summary>
		public static readonly int HIK_PLAYM4_SET_VOLUME_ERROR = 13;
		/// <summary>
		/// ֻڲļʱʹô˽ӿ
		/// The function only support play file.
		/// </summary>
		public static readonly int HIK_PLAYM4_SUPPORT_FILE_ONLY = 14;
		/// <summary>
		/// ֻڲʱʹô˽ӿ
		/// The function only support play stream.
		/// </summary>
		public static readonly int HIK_PLAYM4_SUPPORT_STREAM_ONLY = 15;
		/// <summary>
		/// ϵͳֻ֧֣ܹPentium 3
		/// System not support.
		/// </summary>
		public static readonly int HIK_PLAYM4_SYS_NOT_SUPPORT = 16;
		/// <summary>
		/// ûļͷ
		/// No file header.
		/// </summary>
		public static readonly int HIK_PLAYM4_FILEHEADER_UNKNOWN = 17;
		/// <summary>
		/// ͱ汾Ӧ
		/// The version of decoder and encoder is not adapted.  
		/// </summary>
		public static readonly int HIK_PLAYM4_VERSION_INCORRECT = 18;
		/// <summary>
		/// ʼʧ
		/// Initialize decoder failed.
		/// </summary>
		public static readonly int HIK_PALYM4_INIT_DECODER_ERROR = 19;
		/// <summary>
		/// ļ̫̻޷ʶ
		/// The file data is unknown.
		/// </summary>
		public static readonly int HIK_PLAYM4_CHECK_FILE_ERROR = 20;
		/// <summary>
		/// ʼýʱʧ
		/// Initialize multimedia clock failed.
		/// </summary>
		public static readonly int HIK_PLAYM4_INIT_TIMER_ERROR = 21;
		/// <summary>
		/// λʧ
		/// Blt failed.
		/// </summary>
		public static readonly int HIK_PLAYM4_BLT_ERROR = 22;
		/// <summary>
		/// ʾOverlayʧ
		/// Update failed.
		/// </summary>
		public static readonly int HIK_PLAYM4_UPDATE_ERROR = 23;
		/// <summary>
		/// ļ
		/// Open file error, stream type is multi.
		/// </summary>
		public static readonly int HIK_PLAYM4_OPEN_FILE_ERROR_MULTI = 24;
		/// <summary>
		/// ļ
		/// Open file error, stream type is video.
		/// </summary>
		public static readonly int HIK_PLAYM4_OPEN_FILE_ERROR_VIDEO = 25;
		/// <summary>
		/// JPEGʽѹ
		/// JPEG compress error.
		/// </summary>
		public static readonly int HIK_PLAYM4_JPEG_COMPRESS_ERROR = 26;
		/// <summary>
		/// ִ֧ļİ汾
		/// Don't support the version of this file.
		/// </summary>
		public static readonly int HIK_PLAYM4_EXTRACT_NOT_SUPPORT = 27;
		/// <summary>
		/// ȡƵʧ
		/// Extract video data failed.
		/// </summary>
		public static readonly int HIK_PLAYM4_EXTRACT_DATA_ERROR = 28;

		#endregion

		#region Display buffers
		/// <summary>
		/// Żֵ
		/// </summary>
		public static readonly int MAX_DIS_FRAMES = 50;
		/// <summary>
		/// ŻСֵ
		/// </summary>
		public static readonly int MIN_DIS_FRAMES = 6;
		#endregion

		#region Locate by
		/// <summary>
		/// ֡
		/// </summary>
		public static readonly int BY_FRAMENUM = 1;
		/// <summary>
		/// ʱ
		/// </summary>
		public static readonly int BY_FRAMETIME = 2;
		#endregion

		#region Display type
		/// <summary>
		/// ֱԿʾ
		/// </summary>
		public static readonly int DISPLAY_NORMAL = 1;
		/// <summary>
		/// 1/4ֱԿʾ
		/// </summary>
		public static readonly int DISPLAY_QUARTER = 2;
		#endregion

		#region Timer type
		/// <summary>
		/// һֻʹ16ʱȽ׼
		/// Only 16 timers for every process.Default TIMER;
		/// </summary>
		public static readonly int TIMER_1 = 1;
		/// <summary>
		/// ʹĿûƣʱûTIMER_1׼
		/// Not limit;But the precision less than TIMER_1; 
		/// </summary>
		public static readonly int TIMER_2 = 2;
		#endregion

		#region BUFFER TYPE
		/// <summary>
		/// ƵԴ֮ǰƵݣֻģʽЧλbyte
		/// </summary>
		public static readonly ushort BUF_VIDEO_SRC = 1;
		/// <summary>
		/// ƵԴ֮ǰƵݣֻģʽЧ, λbyte 
		/// </summary>
        public static readonly ushort BUF_AUDIO_SRC = 2;
		/// <summary>
		/// Ƶݻλ֡ 
		/// </summary>
        public static readonly ushort BUF_VIDEO_RENDER = 3;
		/// <summary>
		/// Ƶݻλ֡Ƶ40msݶΪһ֡ 
		/// </summary>
        public static readonly ushort BUF_AUDIO_RENDER = 4;
		#endregion

		#endregion

		#region HikPlayer
		/// <summary>
		/// 1 BOOL Hik_PlayM4_InitDDraw(HWND hWnd);
		/// ʼDirectDraw档ʹvb,delphiʱע⣬ɵĶԻWS_CLIPCHILDREN
		/// ڷ񣬱ȥַ񣬷ʾᱻԻϵĿؼǡע⣺1.1ϲҪá
		/// </summary>
		/// <param name="hWnd">hWnd Ӧóڵľ</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_InitDDraw(IntPtr hWnd);

		/// <summary>
		/// 2 BOOL Hik_PlayM4_RealeseDDraw(); 
		/// ͷdirectDraw棻ע⣺1.1ϲҪá
		/// </summary>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_RealeseDDraw();

		/// <summary>
		/// 3 BOOL Hik_PlayM4_OpenFile(LONG nPort,LPSTR sFileName); 
		/// 򿪲ļ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="sFileName">ļļܳ4GС4K</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_OpenFile(int nPort, string sFileName);

		/// <summary>
		/// 4 BOOL Hik_PlayM4_CloseFile(LONG nPort); 
		/// رղļ
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_CloseFile(int nPort);

		/// <summary>
		/// 5 BOOL Hik_PlayM4_Play(LONG nPort, HWND hWnd); 
		/// ſʼƵСhWndڵҪȫʾֻҪhWndڷŴȫ
		/// ѾţֻǸı䵱ǰٶΪٶȡ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="hWnd">hWnd ƵĴھ</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_Play(int nPort, IntPtr hWnd);

		/// <summary>
		/// 6 BOOL Hik_PlayM4_Stop(LONG nPort); 
		/// Ž
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_Stop(int nPort);

		/// <summary>
		/// 7 BOOL Hik_PlayM4_Pause(LONG nPort,DWORD nPause); 
		/// ͣ/ָ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nPause">nPause=TRUEָͣ</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_Pause(int nPort, bool nPause);

		/// <summary>
		/// 8 BOOL Hik_PlayM4_Fast(LONG nPort); 
		/// ٲţÿεýʹǰٶȼӿһ4ΣҪָŵHik_PlayM4_Play()
		/// ӵǰλÿʼ
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_Fast(int nPort);

		/// <summary>
		/// 9 BOOL Hik_PlayM4_Slow(LONG nPort); 
		/// ٲţÿεýʹǰٶһ4ΣҪָŵHik_PlayM4_Play()
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_Slow(int nPort);

		/// <summary>
		/// 10BOOL Hik_PlayM4_SetPlayPos(LONG nPort,float fRelativePos); 
		/// ļָλãٷֱȣ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="fRelativePos">Χ0-100%</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetPlayPos(int nPort, float fRelativePos);

		/// <summary>
		/// 11float Hik_PlayM4_GetPlayPos(LONG nPort); 
		/// ļָλ
		/// </summary>
		/// <param name="nPort">Χ0-100%</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern float Hik_PlayM4_GetPlayPos(int nPort);

		/// <summary>
		/// 12BOOL Hik_PlayM4_SetFileEndMsg(LONG nPort,HWND hWnd,UINT nMsg); 
		/// ļʱҪ͵Ϣ2.4濪ʼļʱ߳̽ԶҪ
		/// ûֹͣӦóյϢҪòŽHik_PlayM4_Stop(nPort) 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="hWnd">Ϣ͵Ĵڡ </param>
		/// <param name="nMsg">ûԶϢŵļʱûhWndڹյϢϢеwParamnPortֵ</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetFileEndMsg(int nPort, IntPtr hWnd, uint nMsg);

		/// <summary>
		/// 13BOOL Hik_PlayM4_SetVolume(LONG nPort,WORD nVolume); 
		/// ڲ֮ǰãֵFALSEõֵ棬Ϊʱĳʼ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nVolume">ֵΧ0-0XFFFF</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetVolume(int nPort, int nVolume);

		/// <summary>
		/// 14BOOL Hik_PlayM4_PlaySound(LONG nPort);
		/// ͬһʱֻһ·Ѿ򿪣ԶرԭѾ򿪵
		/// ע⣺Ĭǹرյģ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_PlaySound(int nPort);

		/// <summary>
		/// 15BOOL Hik_PlayM4_StopSound(); 
		/// ر
		/// </summary>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_StopSound();

		/// <summary>
		/// 16BOOL  Hik_PlayM4_OpenStream(LONG nPort,PBYTE pFileHeadBuf,DWORD nSize,DWORD nBufPoolSize); 
		/// ӿڣƴļ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="pFileHeadBuf">ûӿϵõļͷݡ</param>
		/// <param name="nSize">ļͷȡ</param>
		/// <param name="nBufPoolSize">òдĻСΧSOURCE_BUF_MIN~ SOURCE_BUF_MAX </param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_OpenStream(int nPort, IntPtr pFileHeadBuf, ushort nSize, ushort nBufPoolSize);

		/// <summary>
		/// 17BOOL Hik_PlayM4_InputData(LONG nPort,PBYTE pBuf,DWORD nSize); 
		/// ӿϵõݣ֮ݡ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="pBuf">ַ</param>
		/// <param name="nSize">С</param>
		/// <returns>TURE,ʾѾݡFALSE ʾʧܣû롣</returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_InputData(int nPort, IntPtr pBuf, ushort nSize);

		/// <summary>
		/// 18BOOL Hik_PlayM4_CloseStream(LONG nPort); 
		/// ر
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_CloseStream(int nPort);

		/// <summary>
		/// 19int Hik_PlayM4_GetCaps(); 
		/// ԲҪһЩϵͳ 
		/// ע⣺Կ֧гʾܣ󽵵CPUʡͼ352*288PALС
		///      Կַ֧ŴСʾҲʹ352*288 
		/// </summary>
		/// <returns>
		/// 1~8λֱʾϢλTRUEʾ֧֣ 
		///    SUPPORT_DDRAW		֧DIRECTDRAW֧֣򲥷ܹ 
		///    SUPPORT_BLT			Կ֧BLT֧֣򲥷ܹ 
		///    SUPPORT_BLTFOURCC	ԿBLT֧ɫת֧֣ʹʽRGBת
		///    SUPPORT_BLTSHRINKX	ԿBLT֧XС֧֣ϵͳʹʽת
		///    SUPPORT_BLTSHRINKY	ԿBLT֧YС֧֣ϵͳʹʽת 
		///    SUPPORT_BLTSTRETCHX	ԿBLT֧XŴ֧֣ϵͳʹʽת
		///    SUPPORT_BLTSTRETCHY	ԿBLT֧YŴ֧֣ϵͳʹʽת 
		///    SUPPORT_SSE			CPU֧SSEָ,Intel Pentium3֧SSEָ
		///    SUPPORT_MMX			CPU֧MMXָ 
		/// </returns>
		[DllImport("HikPlayM4.dll")]
		public static extern int Hik_PlayM4_GetCaps();

		/// <summary>
		/// 20DWORD Hik_PlayM4_GetFileTime(LONG nPort); 
		/// õļܵʱ䳤ȣλ
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern int Hik_PlayM4_GetFileTime(int nPort);

		/// <summary>
		/// 21DWORD Hik_PlayM4_GetPlayedTime(LONG nPort); 
		/// õļǰŵʱ䣬λ
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern ushort Hik_PlayM4_GetPlayedTime(int nPort);

		/// <summary>
		/// 22DWORD Hik_PlayM4_GetPlayedFrames(LONG nPort); 
		/// õѾƵ֡
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern ushort Hik_PlayM4_GetPlayedFrames(int nPort);

		/// <summary>
		/// 23BOOL Hik_PlayM4_OneByOne(LONG nPort); 
		/// ֡šҪָŵHik_PlayM4_Play()
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_OneByOne(int nPort);

		/// <summary>
		/// 24BOOL Hik_PlayM4_SetDecCallBack(LONG nPort,void (CALLBACK* DecCBFun)(long nPort,char * pBuf,long nSize,FRAME_INFO * pFrameInfo, long nReserved1,long nReserved2)); 
		/// ûص滻еʾ֣ûԼʾúHik_PlayM4_Play()֮ǰã
		/// Hik_PlayM4_Stop()ʱԶʧЧ´εHik_PlayM4_Play()֮ǰҪá
		/// ע벿ֲٶȣֻҪûӻصзأͻһݡ
		/// ܵʹҪûƵʾ㹻˽⣬ʹãй֪ʶdirectx
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="dcbf">DecCBFunصָ룬ΪNULL</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetDecCallBack(int nPort, DecCBFun dcbf);

		/// <summary>
		/// 25BOOL Hik_PlayM4_SetDisplayCallBack(LONG nPort,void (CALLBACK* DisplayCBFun)(long nPort,char * pBuf,long nSize,long nWidth,long nHeight,long nStamp,long nType,long nReceaved)); 
		/// ץͼصעҪ췵أҪֹͣص԰ѻصָDisplayCBFunΪNULL
		/// һûصһֱЧֱ˳úκʱá 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="dcbf">DisplayCBFunץͼصΪNULL</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetDisplayCallBack(int nPort, DisplayCBFun dcbf);

		/// <summary>
		/// 26BOOL Hik_PLayM4_ConvertToBmpFile(char * pBuf,long nSize,long nWidth,long nHeight,long nType,char *sFileName);
		/// ץͼõͼݱBMPļתռõcpuԴҪͼƬҪ
		/// </summary>
		/// <param name="pBuf">ͬץͼصеĲ</param>
		/// <param name="nSize">ͬץͼصеĲ</param>
		/// <param name="nWidth">ͬץͼصеĲ</param>
		/// <param name="nHeight">ͬץͼصеĲ</param>
		/// <param name="nType">ͬץͼصеĲ</param>
		/// <param name="sFileName">ҪļBMPΪļչ</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PLayM4_ConvertToBmpFile(IntPtr pBuf, int nSize, int nWidth, int nHeight, int nType, string sFileName);

		/// <summary>
		/// 27DWORD Hik_PlayM4_GetFileTotalFrames(LONG nPort); 
		/// õļе֡ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns>ļе֡ </returns>
		[DllImport("HikPlayM4.dll")]
		public static extern int Hik_PlayM4_GetFileTotalFrames(int nPort);

		/// <summary>
		/// 28DWORD Hik_PlayM4_GetCurrentFrameRate(LONG nPort); 
		/// õǰбʱ֡ʡ
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns>ǰбʱ֡ʡ </returns>
		[DllImport("HikPlayM4.dll")]
		public static extern ushort Hik_PlayM4_GetCurrentFrameRate(int nPort);

		/// <summary>
		/// 29DWORD Hik_PlayM4_GetPlayedTimeEx(LONG nPort); 
		/// õļǰŵʱ䣬λ
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern ushort Hik_PlayM4_GetPlayedTimeEx(int nPort);

		/// <summary>
		/// 30BOOL Hik_PlayM4_SetPlayedTimeEx(LONG nPort,DWORD nTime); 
		/// ʱļλã˽ӿڱHik_PlayM4_SetPlayPosʱʱƲŽ
		/// Hik_PlayM4_GetPlayedTime(Ex)ʹãôʹƽ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nTime">ļλõָʱ䡣λ롣</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetPlayedTimeEx(int nPort, int nTime);

		/// <summary>
		/// 31DWORD Hik_PlayM4_GetCurrentFrameNum(LONG nPort); 
		/// õǰŵ֡šHik_PlayM4_GetPlayedFrames()ܹ֡ļλ
		/// ı䣬ôķֵӦ÷ǳӽʧݡ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern int Hik_PlayM4_GetCurrentFrameNum(int nPort);

		/// <summary>
		/// 32BOOL Hik_PlayM4_SetStreamOpenMode(LONG nPort,DWORD nMode); 
		/// ŵģʽڲ֮ǰá 
		/// ע⣺2.2Ժͣţţ֡Ų 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nMode">STREAME_REALTIMEʵʱģʽĬϣSTREAME_FILEļģʽ</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetStreamOpenMode(int nPort, ushort nMode);

		/// <summary>
		/// 33DWORD Hik_PlayM4_GetFileHeadLength(); 
		/// õǰ汾ܲŵļļͷȡҪӦSTREAME_FILEģʽ¡
		/// ԱļͷΪHik_PlayM4_OpenStream() 
		/// <example>
		/// CFile m_TestFile;
		/// void Start() 
		/// {
		///		//ļͷȣ 
		///		DWORD nLength= Hik_PlayM4_GetFileHeadLength(); 
		///		PBYTE pFileHead=new BYTE[nLength]; 
		///		//ļ 
		///		m_TestFile.Open("test.mp4 ", CFile::modeRead,NULL); 
		///		m_TestFile.Read(pFileHead,nLength); 
		///		//ģʽ 
		///		Hik_PlayM4_SetStreamOpenMode(0,STREAME_FILE); 
		///		//ӿ 
		///		if(!Hik_PlayM4_OpenStream(0,pFileHead, nLength,1024*100)) 
		///		{ 
		///			m_strPlayFileName=""; 
		///			MessageBox("ļ򲻿"); 
		///		} 
		///		// 
		///		m_bPlaying = Hik_PlayM4_Play( 0, m_hWnd); 
		///		delete []pFileHead; 
		/// }  
		/// /////////////////////////////////////////////////////////////////////////////// 
		/// void InputData() 
		/// {
		///		BYTE pBuf[4096]; 
		///		m_TestFile.Read(pBuf,sizeof(pBuf)); 
		///		while(!Hik_PlayM4_InputData(0,pBuf,sizeof(pBuf))) 
		///		{ 
		///			if(!m_bPlaying) 
		///			break;//Ѿֹͣţ˳ 
		///			TRACE("SLEEEP \n"); 
		///			Sleep(5); 
		///		} 
		///  } 
		/// </example>
		/// </summary>
		/// <returns>˰汾Ӧļͷĳȡ </returns>
		[DllImport("HikPlayM4.dll")]
		public static extern ushort Hik_PlayM4_GetFileHeadLength();

		/// <summary>
		/// 34DWORD Hik_PlayM4_GetSdkVersion(); 
		/// õǰsdkİ汾źbuildšֻ޸bugֻbuildš
		/// </summary>
		/// <returns>16λʾǰbuildš9~16λʾ汾ţ1~8λʾΰ汾š磺ֵ0x06040105 ʾbuild0604汾1.5 </returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_GetSdkVersion();

		/// <summary>
		/// 35DWORD Hik_PlayM4_GetLastError(LONG nPort) 
		/// õǰĴ롣ûӦڵĳʧʱô˺ԻôϸϢ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern int Hik_PlayM4_GetLastError(int nPort);

		/// <summary>
		/// 36BOOL Hik_PlayM4_RefreshPlay(LONG nPort)
		/// ˢʾûͣʱˢ˴ڣ򴰿еͼΪˢ¶ʧʱӿڿ
		/// °ͼʾֻͣ͵֡ʱŻִУ ֱӷء 
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_RefreshPlay(int nPort);

		/// <summary>
		/// 37BOOL Hik_PlayM4_SetOverlayMode(LONG nPort,BOOL bOverlay,COLORREF colorKey) 
		/// OVERLAYģʽʾ档һԿͬһʱֻһOVERLAY洦ڻ״̬
		/// ʱϵͳѾгʹOVERLAYôͲٴOVERLAY棬
		/// Off_Screen棬FALSEһЩõĲԼǿԤʹ
		/// overlay档ͬʹOVERLAY棬ôĳ򽫲ʹOVERLAY
		/// 棬رע⣬ǵĿԤʱҲҪʹOVERLAY(û)ȴ򿪲
		/// ʹOVERLAYԤôԤΪòOVERLAYʧܡʹOVERLAY
		/// ģʽŵǣ󲿷ݵԿ֧OVERLAYһЩ֧BLTӲźɫתԿ 
		/// (SISϵԿ)ʹOVERLAYģʽOVERLAYģʽµźɫתԿ֧֣Դ
		/// Сcpuʲ߻źɫתȱǣֻһ·ʹá
		/// ñPLAY֮ǰʹãҪ͸ɫ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="bOverlay">ΪTRUE,ʾȳʹOVERLAYģʽʹģʽΪFALSE,򲻽OVERLAYģʽĳԡ </param>
		/// <param name="colorKey">
		///     ûõ͸ɫ͸ɫ൱һ͸ĤʾĻֻܴɫɫ
		///     סʾĻ档ûӦʾͿɫܿʾ档һӦʹ
		///     һֲõɫΪ͸ɫһ˫ֵֽ0x00rrggbb,ֽΪ0ֽڷֱʾr,g,bֵ
		/// </param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetOverlayMode(int nPort, bool bOverlay,int colorKey);

		/// <summary>
		/// 38BOOL Hik_PlayM4_GetPictureSize(LONG nPort,LONG *pWidth,LONG *pHeight); 
		/// ԭʼͼĴСݴ˴Сʾڵ򣬿ԲԿŹ
		/// Щ֧ӲŵԿ˵ǳá 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="pWidth">ԭʼͼĿPALCIFʽ352</param>
		/// <param name="pHeight">ԭʼͼĸߡPALCIFʽ288</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
        public static extern bool Hik_PlayM4_GetPictureSize(int nPort, out int pWidth, out int pHeight);

		/// <summary>
		/// 39BOOL Hik_PlayM4_SetPicQuality(LONG nPort,BOOL bHighQuality); 
		/// ͼóɸʱЧãCPUʸߡֶ֧·ʱ
		/// ΪԽCPUʣĳ·Ŵ󲥷ʱ·óɸԴﵽõĻЧ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="bHighQuality">1ʱͼ0ʱĬֵ</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetPicQuality(int nPort, bool bHighQuality);

		/// <summary>
		/// 40BOOL Hik_PlayM4_PlaySoundShare(LONG nPort); 
		/// Թʽֻܲű·ȥر·
		/// ע⣺WIN98֮ǰ汾ϵͳִ֧豸Ѿʹãô˺FALSE
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_PlaySoundShare(int nPort);

		/// <summary>
		/// 41BOOL Hik_PlayM4_StopSoundShare(LONG nPort); 
		/// ԹʽرHik_Playm4_PlaySound()Hik_PlayM4_StopSound()Զռʽġ
		/// ע⣺ͬһУͨʹͬķʽŻر
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_StopSoundShare(int nPort);
		
		#endregion

		#region Ϊ2.4ӿ
		/// <summary>
		/// 42LONG Hik_PlayM4_GetStreamOpenMode(LONG nPort); 
		/// ģʽ͡ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns>STREAME_REALTIMESTREAME_FILE</returns>
		[DllImport("HikPlayM4.dll")]
		public static extern int Hik_PlayM4_GetStreamOpenMode(int nPort);

		/// <summary>
		/// 43LONG Hik_PlayM4_GetOverlayMode(LONG nPort); 
		/// 鵱ǰǷʹOVERLAYģʽ
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns>0ʾûʹOVERLAY1ʾʹOVERLAY档</returns>
		[DllImport("HikPlayM4.dll")]
		public static extern int Hik_PlayM4_GetOverlayMode(int nPort);

		/// <summary>
		/// 44COLORREF Hik_PlayM4_GetColorKey(LONG nPort); 
		/// OVERLAYʹõ͸ɫ
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns>ɫֵ</returns>
		[DllImport("HikPlayM4.dll")]
        public static extern uint Hik_PlayM4_GetColorKey(int nPort);

		/// <summary>
		/// 45WORD Hik_PlayM4_GetVolume(LONG nPort); 
		/// õǰõ
		/// </summary>
		/// <param name="nPort">ֵ</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
        public static extern ushort Hik_PlayM4_GetVolume(int nPort);

		/// <summary>
		/// 46BOOL Hik_PlayM4_GetPictureQuality(LONG nPort,BOOL *bHighQuality); 
		/// õǰͼ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="bHighQuality">1ʾ0ʾ </param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_GetPictureQuality(int nPort, out bool bHighQuality);

		/// <summary>
		/// 47DWORD Hik_PlayM4_GetSourceBufferRemain(LONG nPort); 
		/// ģʽԴʣ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns>ǰԴĴСBYTE</returns>
		[DllImport("HikPlayM4.dll")]
		public static extern ushort Hik_PlayM4_GetSourceBufferRemain(int nPort);

		/// <summary>
		/// 48BOOL Hik_PlayM4_ResetSourceBuffer(LONG nPort); 
		/// ģʽԴʣ
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_ResetSourceBuffer(int nPort);

		/// <summary>
		/// 49BOOL Hik_PlayM4_SetSourceBufCallBack(LONG nPort,DWORD nThreShold,void (CALLBACK * SourceBufCallBack)(long nPort,DWORD nBufSize,DWORD dwUser,void*pResvered),DWORD dwUser,void *pReserved); 
		/// ԴֵʣСڵڷֵʱĻصָ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nThreShold">ֵ</param>
		/// <param name="sbcb">صָ</param>
		/// <param name="dwUser">û</param>
		/// <param name="pReserved"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetSourceBufCallBack(int nPort, ushort nThreShold, SourceBufCallBack sbcb, ushort dwUser, IntPtr pReserved);

		/// <summary>
		/// 50BOOL Hik_PlayM4_ResetSourceBufFlag(LONG nPort); 
		/// ûص־λΪЧ״̬ģʽԴ嵽﷧ֵʱû˻صһص
		/// ûҪûص־λܻصÿλص־λΪЧûʵʱûص־
		/// ӿڵҪĿǷֹظصڷֵڶΪûʱҲڶݣ
		/// ʼ״̬£ص־λЧġ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_ResetSourceBufFlag(int nPort);

		/// <summary>
		/// 51BOOL Hik_PlayM4_SetDisplayBuf(LONG nPort,DWORD nNum); 
		/// òŻͼ񻺳СȽҪֱӰ첥ŵԺʱԡ
		/// һΧڻԽԽͬʱʱԽڲļʱûÿԿǿ󻺳壨ڴ㹻󣩣
		/// ǵĬֵ15֡25֡/¼0.6ݡڲʱǵĬֵ10(֡)
		/// û׷ʱСԿԵСֵ nNum Ż󻺳֡
		/// ΧMIN_DIS_FRAMES ~MAX_DIS_FRAMESһ֡352*288ͼڴСֵ 352*288*3/2Լ150K 
		/// ֵ352*288*4Լ405K 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nNum"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetDisplayBuf(int nPort, ushort nNum);

		/// <summary>
		/// òŻ󻺳֡
		/// 
		/// 52DWORD  Hik_PlayM4_GetDisplayBuf(LONG nPort); 
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns>Ż󻺳֡</returns>
		[DllImport("HikPlayM4.dll")]
		public static extern ushort Hik_PlayM4_GetDisplayBuf(int nPort);

		/// <summary>
		/// 53BOOL Hik_PlayM4_SetFileRefCallBack(LONG nPort,  void (__stdcall *pFileRefDone) (DWORD nPort,DWORD nUser),DWORD nUser); 
		/// ûصָ룬ļصΪļ׼ȷٵĶλļ򿪵ʱļ
        /// ̺ʱȽϳԼÿ봦40MҵݣҪΪӲ̶ݱȽ
        /// Ĺں̨ɣҪʹĺҪȴ̽ӿڲܵӰ졣 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="frd">صָ</param>
		/// <param name="nUser">û</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetFileRefCallBack(int nPort, FileRefDone frd, ushort nUser);

		/// <summary>
		/// 54BOOL Hik_PlayM4_OneByOneBack(LONG nPort); 
		/// ֡طšÿһεһ֡˺ļ֮ܵá
		/// ȻSetCurrentFrameNum()Ҳ֡ˣЧҪͺܶࡣڵ֡طʱǽʹӿڡ
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_OneByOneBack(int nPort);

		/// <summary>
		/// 55BOOL Hik_PlayM4_SetCurrentFrameNum(LONG nPort,DWORD nFrameNum); 
		/// õǰŲλõָ֡ţ֡λλá˺ļ֮ܵ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nFrameNum">֡</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetCurrentFrameNum(int nPort, int nFrameNum);

		/// <summary>
		/// 56BOOL Hik_PlayM4_GetKeyFramePos(LONG nPort,DWORD nValue, DWORD nType, PFRAME_POS pFramePos); 
		/// ָλ֮ǰĹؼ֡λáͼӹؼ֡ʼûļǴ
		/// ؼ֡ʼģôһؼ֮֡ǰݻᱻԡûҪȡļеһݣ
		/// ӦÿǴӹؼ֡ʼȡλϵඪʧ3֡ݡ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nValue">ǰλãʱ֡ţnTypeָ</param>
		/// <param name="nType">ָnValue͡nType BY_FRAMENUMnValueʾ֡BY_FRAMTIMEnValueʾʱ䣬λms </param>
		/// <param name="pFramePos">ҵĹؼ֡ļλã֡ţʱϢ </param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_GetKeyFramePos(int nPort, ushort nValue, ushort nType, ref PFRAME_POS pFramePos);

		/// <summary>
		/// 57BOOL Hik_PlayM4_GetNextKeyFramePos(LONG nPort,DWORD nValue, DWORD nType, PFRAME_POS pFramePos);
		/// ָλ֮Ĺؼ֡λá
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nValue">ǰλãʱ֡ţnTypeָ</param>
		/// <param name="nType">ָnValue͡nType BY_FRAMENUMnValueʾ֡ţnType Y_FRAMTIMEnValueʾʱ䣬λms</param>
		/// <param name="pFramePos">ҵĹؼ֡ļλã֡ţʱϢ</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_GetNextKeyFramePos(int nPort, ushort nValue, ushort nType, ref PFRAME_POS pFramePos);

		/// <summary>
		/// 58BOOL Hik_PlayM4_ThrowBFrameNum(LONG nPort,DWORD nNum); 
		/// òB֡֡B֡ԼСCPUʣûB֡ô
		/// ֵáڿٲţֶ֧·CPU̫ߵ¿Կʹá 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nNum">B֡֡nNum ǵDS-400XMϵа忨ɼļnNumΧ0~2</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_ThrowBFrameNum(int nPort, int nNum);

		///////////////////////////////////////////////////////////////////////////////////////////////
		//ע⣺59~64ӿڣΪֶ֧ԿӵġWindows98,Windows2000Windows2000֮
		//		ϵͳֶ֧ԿҪװDirectX6.0߰汾ûֶ֧Կ⼸
		//		ڿԲ迼ǡڶԿıοMicrosoft sdkĵ"Multiple-Monitor Systems"
		///////////////////////////////////////////////////////////////////////////////////////////////
		/// <summary>
		/// 59BOOL Hik_PlayM4_InitDDrawDevice(); 
		/// öϵͳеʾ豸
		/// </summary>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_InitDDrawDevice();

		/// <summary>
		/// 60void Hik_PlayM4_ReleaseDDrawDevice(); 
		/// ͷöʾ豸ĹзԴ
		/// </summary>
		[DllImport("HikPlayM4.dll")]
		public static extern void Hik_PlayM4_ReleaseDDrawDevice();

		/// <summary>
		/// 61DWORD Hik_PlayM4_GetDDrawDeviceTotalNums(); 
		/// ϵͳwindows󶨵ܵʾ豸ĿҪָԿ
		/// </summary>
		/// <returns>
		///     0ʾϵͳֻʾ豸1ʾϵͳаװ˶Կ
		///     ֻһԿWindows󶨡ֵʾϵͳ󶨵ԿĿڶԿ
		///     ϵͳпͨʾԣָһԿΪʾ豸 
		/// </returns>
		[DllImport("HikPlayM4.dll")]
		public static extern int Hik_PlayM4_GetDDrawDeviceTotalNums();

		/// <summary>
		/// 62BOOL Hik_PlayM4_SetDDrawDevice(LONG nPort,DWORD nDeviceNum);
		/// òŴʹõԿע⣺ôڱڸԿӦļϲʾŻ档
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nDeviceNum">ʾ豸豸ţ0ʾʹʾ豸</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetDDrawDevice(int nPort, int nDeviceNum);

		/// <summary>
		/// 63BOOL Hik_PlayM4_GetDDrawDeviceInfo(DWORD nDeviceNum,LPSTR lpDriverDescription,DWORD nDespLen,LPSTR lpDriverName ,DWORD nNameLen,HMONITOR *hhMonitor); 
		/// õָԿͼϢ
		/// </summary>
		/// <param name="nDeviceNum">ʾ豸豸ţ0ʾʾ豸</param>
		/// <param name="lpDriverDescription">ʾ豸Ϣ </param>
		/// <param name="nDespLen">ʾlpDriverDescriptionѷռĴСλbyte</param>
		/// <param name="lpDriverName">ʾ豸豸 </param>
		/// <param name="nNameLen">ʾlpDriverNameѷռĴСλbyte</param>
		/// <param name="hhMonitor">
		///		ʾ豸ʹõļͨWindows API GetMonitorInfoԵõϸϢûλλá
		///     ע⣺HMONITOR _WIN32_WINNT >= 0x0500ʱڡwindef.hͷļж壬
		///		ڡMultimon.Hж壬ûڱҲͶ壬԰Ӧͷļ 
		/// </param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_GetDDrawDeviceInfo(int nDeviceNum, string lpDriverDescription, ushort nDespLen, string lpDriverName, ushort nNameLen, IntPtr hhMonitor);

		/// <summary>
		/// 64int Hik_PlayM4_GetCapsEx(DWORD nDDrawDeviceNum);
		/// ָʾ豸ϵͳϢֶ֧Կ
		/// </summary>
		/// <param name="nDDrawDeviceNum">ָʾ豸豸ţ0ʾʾ豸</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern int Hik_PlayM4_GetCapsEx(int nDDrawDeviceNum);

		/// <summary>
		/// 65BOOL Hik_PlayM4_SetDisplayType(LONG nPort,LONG nType);
		/// ʾģʽСʾʱDISPLAY_QUARTER ԼСԿӶ
		/// ָ֧·ʾʾ½ʹʾʱӦʹDISPLAY_NORMAL
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nType">nType ģʽDISPLAY_NORMALDISPLAY_QUARTER</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetDisplayType(int nPort, int nType);

		/// <summary>
		/// 66long Hik_PlayM4_GetDisplayType(LONG nPort);
		/// Ŀǰõʾģʽ
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns>DISPLAY_NORMAL  DISPLAY_QUARTER</returns>
		[DllImport("HikPlayM4.dll")]
		public static extern int Hik_PlayM4_GetDisplayType(int nPort);

		/// <summary>
		/// 67BOOL __stdcall Hik_PlayM4_SetDecCBStream(LONG nPort,DWORD nStream);
		/// ýص͡
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nStream">1Ƶ2Ƶ3</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetDecCBStream(int nPort, ushort nStream);

		/// <summary>
		/// 68BOOL __stdcall Hik_PlayM4_SetDisplayRegion(LONG nPort,DWORD nRegionNum, RECT *pSrcRect, HWND hDestWnd, BOOL bEnable); 
		/// ûʾ򡣿ֲŴʾ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nRegionNum">ʾţ0~(MAX_DISPLAY_WND-1)nRegionNumnRegionNumΪ0
		/// ʾҪʾ(Hik_PlayM4_PlayõĴ)ãhDestWndbEnableá</param>
		/// <param name="pSrcRect">Ҫʾԭʼͼϵ磺ԭʼͼ352*288
		/// ôpSrcRectõķΧֻڣ00352288֮СpSrcRect=NULL,ʾͼ</param>
		/// <param name="hDestWnd">ʾڡĴѾù򿪹ôòԡ</param>
		/// <param name="bEnable">򿪣ãرʾ</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetDisplayRegion(int nPort, ushort nRegionNum, ref Rectangle pSrcRect, IntPtr hDestWnd, bool bEnable);

		/// <summary>
		/// 69BOOL __stdcall Hik_PlayM4_RefreshPlayEx(LONG nPort,DWORD nRegionNum); 
		/// ˢʾͬ36Ϊ֧Hik_PlayM4_SetDisplayRegionһ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nRegionNum">ʾš</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_RefreshPlayEx(int nPort, ushort nRegionNum);

		/// <summary>
		/// 70BOOL __stdcall Hik_PlayM4_SetDDrawDeviceEx(LONG nPort,DWORD nRegionNum,DWORD nDeviceNum);
		/// òŴʹõԿͬ62Ϊ֧Hik_PlayM4_SetDisplayRegionһ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nRegionNum">ʾš</param>
		/// <param name="nDeviceNum"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetDDrawDeviceEx(int nPort, ushort nRegionNum, ushort nDeviceNum);

		/// <summary>
		/// 71BOOL __stdcall Hik_PlayM4_OpenStreamEx(LONG nPort,PBYTE pFileHeadBuf,DWORD nSize,DWORD nBufPoolSize);
		/// Ƶֿķʽ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="pFileHeadBuf">ûӿϵõļͷݡ</param>
		/// <param name="nSize">ļͷ </param>
		/// <param name="nBufPoolSize"> òдĻСΧSOURCE_BUF_MIN~ SOURCE_BUF_MAX</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_OpenStreamEx(int nPort, IntPtr pFileHeadBuf, ushort nSize, ushort nBufPoolSize);

		/// <summary>
		/// 72BOOL __stdcall Hik_PlayM4_CloseStreamEx(LONG nPort);
		/// ر
		/// </summary>
		/// <param name="nPort"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_CloseStreamEx(int nPort);

		/// <summary>
		/// 73BOOL __stdcall Hik_PlayM4_InputVideoData(LONG nPort,PBYTE pBuf,DWORD nSize);
		/// ӿϵõƵ (ǸƵݻᱻ)֮ݡ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="pBuf">ַ</param>
		/// <param name="nSize">С</param>
		/// <returns>TURE,ʾѾݡFALSE ʾʧܣû롣</returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_InputVideoData(int nPort, IntPtr pBuf, ushort nSize);

		/// <summary>
		/// 74BOOL __stdcall Hik_PlayM4_InputAudioData(LONG nPort,PBYTE pBuf,DWORD nSize);
		/// ӿϵõƵ֮ݡ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="pBuf">ַ</param>
		/// <param name="nSize">С</param>
		/// <returns>ֵTURE,ʾѾݡFALSE ʾʧܣû롣</returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_InputAudioData(int nPort, IntPtr pBuf, ushort nSize);

		/// <summary>
		/// 75BOOL __stdcall Hik_PlayM4_RigisterDrawFun(LONG nPort,void (CALLBACK* DrawFun)(long nPort,HDC hDc,LONG nUser),LONG nUser);
		/// עһصõǰdevice context, DCϻͼд֣ͺڴڵĿͻDCϻͼ
		/// DCǴڿͻDCDirectDrawOff-ScreenDCע⣬ʹoverlay棬ӿЧ
		/// ֱڴϻͼֻҪ͸ɫͲᱻǡ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="df">ص</param>
		/// <param name="nUser">û</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_RigisterDrawFun(int nPort, DrawFun df, int nUser);

		/// <summary>
		/// 76BOOL __stdcall Hik_PlayM4_GetRefValue(LONG nPort,BYTE *pBuffer, DWORD *pSize);
		/// ȡļϢԱ´δͬһļʱֱʹϢɺܻϢ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="pBuffer">Ϣ</param>
		/// <param name="pSize">
		///		/pBufferĴСϢС
		///     עڵһָpSize=0,pBuffer=NULL
		///     pSizeķֵҪĻСȻ㹻Ļ壬ٵһ 
		/// </param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_GetRefValue(int nPort, IntPtr pBuffer, ref ushort pSize);

		/// <summary>
		/// 77BOOL __stdcall Hik_PlayM4_SetRefValue(LONG nPort,BYTE *pBuffer, DWORD nSize);
		/// ļѾļϢԲٵĻص(53.Hik_PlayM4_SetFileRefCallBack)
		/// ֱϢעϢ䳤ȱ׼ȷ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="pBuffer">Ϣ</param>
		/// <param name="nSize">Ϣĳ</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetRefValue(int nPort, IntPtr pBuffer, ushort nSize);

		/// <summary>
		/// 78BOOL __stdcall Hik_PlayM4_SetTimerType(LONG nPort,DWORD nTimerType,DWORD nReserved);
		/// òʹõĶʱע⣺Open֮ǰ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nTimerType">TIMER_1TIMER_2궨塣Ĭ0~15·ʹTIMER_1ʹTIMER_2</param>
		/// <param name="nReserved"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetTimerType(int nPort, int nTimerType, ushort nReserved);

		/// <summary>
		/// 79BOOL __stdcall Hik_PlayM4_GetTimerType(LONG nPort,DWORD *pTimerType,DWORD *pReserved);
		/// õǰͨʹõĶʱ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="pTimerType">TIMER_1TIMER_2</param>
		/// <param name="pReserved"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_GetTimerType(int nPort, out ushort pTimerType, out ushort pReserved);

		/// <summary>
		/// 80BOOL __stdcall Hik_PlayM4_ResetBuffer(LONG nPort,DWORD nBufType);
		/// ղеĻ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nBufType"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_ResetBuffer(int nPort, int nBufType);

		/// <summary>
		/// 81DWORD __stdcall Hik_PlayM4_GetBufferValue(LONG nPort,DWORD nBufType);
		/// ȡеĻС֡byteӿڿ԰û˽⻺еݣӶʱơ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nBufType"></param>
		/// <returns>ݲͬػֵԴbyte,󻺳֡</returns>
		[DllImport("HikPlayM4.dll")]
		public static extern ushort Hik_PlayM4_GetBufferValue(int nPort, ushort nBufType);

		/// <summary>
		/// 82BOOL __stdcall Hik_PlayM4_AdjustWaveAudio(LONG nPort,LONG nCoefficient);
		/// WAVEΣԸıĴСHik_PlayM4_SetVolume()Ĳͬڣǵݣ
		/// ֻԸ·ãHik_PlayM4_SetVolumeǵϵͳá
		/// ע⣬ƻʣÿ·ʹá 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nCoefficient">ĲΧMIN_WAVE_COEF  MAX_WAVE_COEF0ǲ</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_AdjustWaveAudio(int nPort, int nCoefficient);

		/// <summary>
		/// 83BOOL __stdcall Hik_PlayM4_SetVerifyCallBack(LONG nPort, DWORD nBeginTime, DWORD nEndTime, void (__stdcall* funVerify)(long nPort, FRAME_POS * pFilePos, DWORD bIsVideo, DWORD nUser),  DWORD  nUser); 
		/// עһصУǷ޸ģʵˮӡܡڿԷݶʧ
		/// ע⣬УڽļʱУԱ뽨ļУ顣openfile֮ǰʹá
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nBeginTime">У鿪ʼʱ䣬λms</param>
		/// <param name="nEndTime">Уʱ䣬λms</param>
		/// <param name="vfy">ݱ޸ʱصĺ</param>
		/// <param name="nUser">û</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetVerifyCallBack(int nPort, uint nBeginTime, uint nEndTime, Verify vfy, uint nUser);

		/// <summary>
		/// 84BOOL __stdcall Hik_PlayM4_SetAudioCallBack(LONG nPort, void (__stdcall * funAudio)(long nPort, char * pAudioBuf, long nSize, long nStamp, long nType, long nUser), long nUser);
		/// Ƶ֡waveݻص
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nBufType"></param>
		/// <param name="ado">Ƶص</param>
		/// <param name="nUser">ûԶ</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetAudioCallBack(int nPort, Audio ado, int nUser);

		/// <summary>
		/// 85BOOL __stdcall Hik_PlayM4_SetEncTypeChangeCallBack(LONG nPort,void(CALLBACK *funEncChange)(long nPort,long nUser),long nUser);
		/// ʱͼʽı֪ͨûĻصڴļǰʹ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="ec">ص</param>
		/// <param name="nUser">ûԶ</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetEncTypeChangeCallBack(int nPort, EncChange ec, int nUser);

		/// <summary>
		/// 86BOOL __stdcall Hik_PlayM4_SetColor(LONG nPort, DWORD nRegionNum, int nBrightness, int nContrast, int nSaturation, int nHue);
		/// ͼƵʱ
		/// ע⣺ȫΪĬֵɫ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nRegionNum">ʾ򣬲οHik_PlayM4_SetDisplayRegionֻһʾ(ͨ)Ϊ0</param>
		/// <param name="nBrightness">ȣĬ64 Χ0-128</param>
		/// <param name="nContrast">ԱȶȣĬ64 Χ0-128</param>
		/// <param name="nSaturation">ͶȣĬ64 Χ0-128</param>
		/// <param name="nHue">ɫĬ64 Χ0-128</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetColor(int nPort, ushort nRegionNum, int nBrightness, int nContrast, int nSaturation, int nHue);

		/// <summary>
		/// 87BOOL __stdcall Hik_PlayM4_GetColor(LONG nPort, DWORD nRegionNum, int *pBrightness, int *pContrast, int *pSaturation, int *pHue);
		/// ӦĻɫֵ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="nRegionNum">ʾ򣬲οHik_PlayM4_SetDisplayRegionֻһʾ(ͨ)Ϊ0</param>
		/// <param name="nBrightness">ȣĬ64 Χ0-128</param>
		/// <param name="nContrast">ԱȶȣĬ64 Χ0-128</param>
		/// <param name="nSaturation">ͶȣĬ64 Χ0-128</param>
		/// <param name="nHue">ɫĬ64 Χ0-128</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_GetColor(int nPort, ushort nRegionNum, out int pBrightness, out int pContrast, out int pSaturation, out int pHue);

		/// <summary>
		/// 88BOOL __stdcall Hik_PlayM4_SetEncChangeMsg(LONG nPort,HWND hWnd,UINT nMsg)
		/// ýʱʽıʱҪ͵Ϣ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="hWnd">Ϣ͵Ĵڡ</param>
		/// <param name="nMsg">ûϢýʱʽıʱҪʹ˶ϢϢеwParamֵǷnPortֵ </param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetEncChangeMsg(int nPort, IntPtr hWnd, uint nMsg);

		/// <summary>
		/// 89BOOL _stdcall Hik_PlayM4_GetOriginalFrameCallBack(LONG nPort, BOOL bIsChange, BOOL bNormalSpeed, long nStartFrameNum, long nStartStamp, long nFileHeader, void(CALLBACK *funGetOrignalFrame)(long nPort,FRAME_TYPE *frameType, long nUser), long nUser)
		/// õԭʼ֡ݵĻصԸıÿ֡ʱ֡ţļ֮áڽļƴһ
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="bIsChange">ǷҪıÿ֡Ĳ</param>
		/// <param name="bNormalSpeed">ǷҪٶȵõԭʼ֡</param>
		/// <param name="nStartFrameNum">Ҫıԭʼ֡֡ţǴļĿʼ֡</param>
		/// <param name="nStartStamp">Ҫıԭʼ֡ʱ꣬ǴļĿʼʱ</param>
		/// <param name="nFileHeader">:ļͷ汾Ϣ汾ƥ䣬زɹ</param>
		/// <param name="gof"></param>
		/// <param name="nUser">û</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_GetOriginalFrameCallBack(int nPort, bool bIsChange, bool bNormalSpeed, int nStartFrameNum, int nStartStamp, out int nFileHeader, GetOrignalFrame gof, int nUser);

		/// <summary>
		/// 90BOOL _stdcall Hik_PlayM4_GetFileSpecialAttr(LONG nPort, DWORD *pTimeStamp,DWORD *pFileNum ,DWORD *nFileHeader)
		/// õļʱ֡ţļ֮áϸļһʹãļƴӡ 
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="pTimeStamp">ļʱ</param>
		/// <param name="pFileNum">ļ֡</param>
		/// <param name="nFileHeader">ļͷϢ</param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_GetFileSpecialAttr(int nPort, ref ushort pTimeStamp, ref ushort pFileNum, ref ushort nFileHeader);
		#endregion

		#region Ϊ4.7(build0711)ӿ

		/// <summary>
		/// 91.BOOL _stdcall Hik_PlayM4_ConvertToJpegFile(char *pBuf, long nSize, long nWidth, int nHeight, long nType, char *sFileName)
		/// ץͼΪJPEGļ, úʾصʹ, ÷μHik_PlayM4_ConvertToBmpFile(); 
		/// </summary>
		/// <param name="pBuf">ͼݻ</param>
		/// <param name="nSize">ͼС</param>
		/// <param name="nWidth">ͼ</param>
		/// <param name="nHeight">ͼ</param>
		/// <param name="nType">ͼYV12</param>
		/// <param name="sFileName">jpegļ· </param>
		/// <returns>
		///		TRUE: Jpegļɹ
		///		FALSE: ʧ, ɵHik_PlayM4_GetLastError()ȡ 
		/// </returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_ConvertToJpegFile(byte[] pBuf, int nSize, int nWidth, int nHeight, int nType, string sFileName);

		/// <summary>
		/// 92BOOL _stdcall Hik_PlayM4_SetJpegQuality(long nQuality)
		/// ץȡjpegͼ, ÷Χ0~100, ʹ75~90, øú, Ĭͼ, ĿǰĬΪ80 
		/// </summary>
		/// <param name="nQuality">
		///	, Χ0~100
		///     0:   ͼ, ץȡͼСС 
		///     100: ͼ, ץȡͼС 
		/// </param>
		/// <returns>
		///		TRUE: óɹ, õ
		///		FALSE: ʧ, Ĭֵ, ɵHik_PlayM4_GetLastError()ȡ 
		/// </returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetJpegQuality(int nQuality);

		/// <summary>
		/// 93BOOL _stdcall Hik_PlayM4_SetDeflash(LONG nPort,BOOL bDeflash)
		/// Ƿȥ˸, ԭھֹͼ, ͼ˸󣨻ˢ»
		/// ȥ˸ܺ˸ЧᣬͬʱҲܽ 
		/// </summary>
		/// <param name="nPort">ͨ</param>
		/// <param name="bDeflash"> TRUEʾȥ˸FALSEʾãĬΪ</param>
		/// <returns>TRUE: óɹFALSE: ʧ, Ĭֵ, ɵHik_PlayM4_GetLastError()ȡ </returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetDeflash(int nPort, bool bDeflash);
		#endregion

		#region Ϊ4.8(build0813)ӿ
		/// <summary>
		/// 94BOOL __stdcall Hik_PlayM4_CheckDiscontinuousFrameNum(LONG nPort, BOOL bCheck)
		/// ֡ŲʱǷһI֡
		/// </summary>
		/// <param name="nPort">ͨ</param>
		/// <param name="bCheck">֡ŲʱǷһI֡</param>
		/// <returns>TRUE:  óɹ  FALSE: ʧ </returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_CheckDiscontinuousFrameNum(int nPort, bool bCheck);

		/// <summary>
		/// 95BOOL __stdcall Hik_PlayM4_GetBMP(LONG nPort,PBYTE pBitmap,DWORD nBufSize,DWORD* pBmpSize);
		/// ץȡbmpͼ 
		/// </summary>
		/// <param name="nPort">ͨ</param>
		/// <param name="pBitmap">
		///     BMPͼݵַû䣬СbmpͼС
		///     sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + w * h * 4 whֱΪͼߡ 
		/// </param>
		/// <param name="nBufSize">ĻС</param>
		/// <param name="pBmpSize">ȡʵbmpͼС</param>
		/// <returns>TRUE:  ȡɹ FALSE: ȡʧ </returns>
		[DllImport("HikPlayM4.dll")]
        public static extern bool Hik_PlayM4_GetBMP(int nPort, byte[] pBitmap, int nBufSize, out int pBmpSize);

		/// <summary>
		/// 96BOOL __stdcall Hik_PlayM4_GetJPEG(LONG nPort,PBYTE pJpeg,DWORD nBufSize,DWORD* pJpegSize);
		/// ץȡjpegͼ
		/// </summary>
		/// <param name="nPort">ͨ</param>
		/// <param name="pJpeg">JEPGͼݵַû䣬СJPEGͼССw * h * 3/2 whֱΪͼߡ</param>
		/// <param name="nBufSize">ĻС</param>
		/// <param name="pJpegSize">ȡʵbmpͼС</param>
		/// <returns>TRUE:   ȡɹ  FALSE:  ȡʧ</returns>
		[DllImport("HikPlayM4.dll")]
        public static extern bool Hik_PlayM4_GetJPEG(int nPort, byte[] pJpeg, int nBufSize, out int pJpegSize);

		/// <summary>
		/// 97BOOL __stdcall Hik_PlayM4_SetDecCallBackMend(LONG nPort,void (CALLBACK* DecCBFun)(long nPort,char * pBuf,long nSize,FRAME_INFO * pFrameInfo, long nUser, long nReserved2), long nUser);
		/// ûص滻еʾ֣ûԼʾúHik_PlayM4_Play֮ǰã
		/// Hik_PlayM4_StopʱԶʧЧ´εHik_PlayM4_Play֮ǰҪá
		/// ע벿ֲٶȣֻҪûӻصзأͻһݡ
		/// ʹҪûƵʾ㹻˽⣬ʹãй֪ʶdirectx
		/// </summary>
		/// <param name="nPort"></param>
		/// <param name="dcbf">DecCBFunصָ룬ΪNULL</param>
		/// <param name="nUser"></param>
		/// <returns></returns>
		[DllImport("HikPlayM4.dll")]
		public static extern bool Hik_PlayM4_SetDecCallBackMend(int nPort, DecCBFun dcbf, int nUser);
		#endregion
	}
}
