﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Reflection;
using System.Windows.Forms;

namespace NHikPlayer
{
    partial class FormLocation : Form
    {
        private Label lblTitle;
        private Button btnOk;
        private Line line;
        private GroupBox grbType;
        private Button btnFrame;
        private Button btnTime;
        private Label lblLocation;
        private Label lblTime;
        private Label lblFrame;
        private Label lblMsg;
        private NumericTextBox ntxbValue;

        private int nPort = 0;
        private bool bFileRefCreated = false;
        private int nMaxFrame = 0;
        private int nMaxTime = 0;
        private int nValue = -1;

        /// <summary>
        /// 必需的设计器变量。
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        /// <summary>
        /// 清理所有正在使用的资源。
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        #region Windows 窗体设计器生成的代码

        /// <summary>
        /// 设计器支持所需的方法 - 不要
        /// 使用代码编辑器修改此方法的内容。
        /// </summary>
        private void InitializeComponent()
        {
            this.lblTitle = new System.Windows.Forms.Label();
            this.btnOk = new System.Windows.Forms.Button();
            this.grbType = new System.Windows.Forms.GroupBox();
            this.ntxbValue = new NHikPlayer.NumericTextBox();
            this.lblMsg = new System.Windows.Forms.Label();
            this.lblLocation = new System.Windows.Forms.Label();
            this.lblTime = new System.Windows.Forms.Label();
            this.lblFrame = new System.Windows.Forms.Label();
            this.btnFrame = new System.Windows.Forms.Button();
            this.btnTime = new System.Windows.Forms.Button();
            this.line = new NHikPlayer.Line();
            this.grbType.SuspendLayout();
            this.SuspendLayout();
            // 
            // lblTitle
            // 
            this.lblTitle.AutoSize = true;
            this.lblTitle.Font = new System.Drawing.Font("黑体", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(134)));
            this.lblTitle.ForeColor = System.Drawing.Color.SteelBlue;
            this.lblTitle.Location = new System.Drawing.Point(114, 12);
            this.lblTitle.Name = "lblTitle";
            this.lblTitle.Size = new System.Drawing.Size(144, 16);
            this.lblTitle.TabIndex = 0;
            this.lblTitle.Text = "视频文件播放定位";
            // 
            // btnOk
            // 
            this.btnOk.Location = new System.Drawing.Point(257, 228);
            this.btnOk.Name = "btnOk";
            this.btnOk.Size = new System.Drawing.Size(75, 23);
            this.btnOk.TabIndex = 5;
            this.btnOk.Text = "关闭";
            this.btnOk.UseVisualStyleBackColor = true;
            this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
            // 
            // grbType
            // 
            this.grbType.Controls.Add(this.ntxbValue);
            this.grbType.Controls.Add(this.lblMsg);
            this.grbType.Controls.Add(this.lblLocation);
            this.grbType.Controls.Add(this.lblTime);
            this.grbType.Controls.Add(this.lblFrame);
            this.grbType.Location = new System.Drawing.Point(24, 52);
            this.grbType.Name = "grbType";
            this.grbType.Size = new System.Drawing.Size(324, 158);
            this.grbType.TabIndex = 2;
            this.grbType.TabStop = false;
            this.grbType.Text = "定位范围";
            // 
            // ntxbValue
            // 
            this.ntxbValue.AllowSpace = false;
            this.ntxbValue.Location = new System.Drawing.Point(106, 99);
            this.ntxbValue.MaxLength = 214;
            this.ntxbValue.Name = "ntxbValue";
            this.ntxbValue.Size = new System.Drawing.Size(167, 21);
            this.ntxbValue.TabIndex = 3;
            this.ntxbValue.Text = "0";
            this.ntxbValue.TextChanged += new System.EventHandler(this.ntxbValue_TextChanged);
            // 
            // lblMsg
            // 
            this.lblMsg.AutoSize = true;
            this.lblMsg.ForeColor = System.Drawing.Color.Red;
            this.lblMsg.Location = new System.Drawing.Point(106, 126);
            this.lblMsg.Name = "lblMsg";
            this.lblMsg.Size = new System.Drawing.Size(101, 12);
            this.lblMsg.TabIndex = 4;
            this.lblMsg.Text = "错误：超出范围。";
            this.lblMsg.Visible = false;
            // 
            // lblLocation
            // 
            this.lblLocation.AutoSize = true;
            this.lblLocation.Location = new System.Drawing.Point(21, 103);
            this.lblLocation.Name = "lblLocation";
            this.lblLocation.Size = new System.Drawing.Size(89, 12);
            this.lblLocation.TabIndex = 2;
            this.lblLocation.Text = "帧数或者时间：";
            // 
            // lblTime
            // 
            this.lblTime.AutoSize = true;
            this.lblTime.Location = new System.Drawing.Point(21, 62);
            this.lblTime.Name = "lblTime";
            this.lblTime.Size = new System.Drawing.Size(107, 12);
            this.lblTime.TabIndex = 1;
            this.lblTime.Text = "时间范围(秒)：0~0";
            // 
            // lblFrame
            // 
            this.lblFrame.AutoSize = true;
            this.lblFrame.Location = new System.Drawing.Point(21, 35);
            this.lblFrame.Name = "lblFrame";
            this.lblFrame.Size = new System.Drawing.Size(107, 12);
            this.lblFrame.TabIndex = 0;
            this.lblFrame.Text = "帧数范围(帧)：0~0";
            // 
            // btnFrame
            // 
            this.btnFrame.Location = new System.Drawing.Point(47, 228);
            this.btnFrame.Name = "btnFrame";
            this.btnFrame.Size = new System.Drawing.Size(75, 23);
            this.btnFrame.TabIndex = 3;
            this.btnFrame.Text = "定位帧数";
            this.btnFrame.UseVisualStyleBackColor = true;
            this.btnFrame.Click += new System.EventHandler(this.btnFrame_Click);
            // 
            // btnTime
            // 
            this.btnTime.Location = new System.Drawing.Point(146, 228);
            this.btnTime.Name = "btnTime";
            this.btnTime.Size = new System.Drawing.Size(75, 23);
            this.btnTime.TabIndex = 4;
            this.btnTime.Text = "定位时间";
            this.btnTime.UseVisualStyleBackColor = true;
            this.btnTime.Click += new System.EventHandler(this.btnTime_Click);
            // 
            // line
            // 
            this.line.Location = new System.Drawing.Point(12, 37);
            this.line.Name = "line";
            this.line.Size = new System.Drawing.Size(350, 10);
            this.line.TabIndex = 1;
            this.line.Text = "line1";
            // 
            // FormLocation
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 12F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            this.ClientSize = new System.Drawing.Size(374, 270);
            this.Controls.Add(this.btnTime);
            this.Controls.Add(this.btnFrame);
            this.Controls.Add(this.grbType);
            this.Controls.Add(this.line);
            this.Controls.Add(this.btnOk);
            this.Controls.Add(this.lblTitle);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "FormLocation";
            this.Padding = new System.Windows.Forms.Padding(9, 8, 9, 8);
            this.ShowIcon = false;
            this.ShowInTaskbar = false;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "文件定位";
            this.Load += new System.EventHandler(this.FormLocation_Load);
            this.grbType.ResumeLayout(false);
            this.grbType.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        #endregion

        public FormLocation(int Port, bool FileRefCreated)
        {
            InitializeComponent();
            nPort = Port;
            bFileRefCreated = FileRefCreated;
        }

        private void FormLocation_Load(object sender, EventArgs e)
        {
            nMaxFrame = HikPlayer.PlayM4_GetFileTotalFrames(nPort);
            nMaxTime = HikPlayer.PlayM4_GetFileTime(nPort);

            if (nMaxFrame == 0)
                this.btnFrame.Enabled = false;
            else
                this.lblFrame.Text = string.Format("帧数范围(帧)：0~{0:D}", nMaxFrame - 1);

            if (nMaxTime == 0)
                this.btnTime.Enabled = false;
            else
                this.lblTime.Text = string.Format("时间范围(秒)：0~{0:D}", nMaxTime);
        }

        private void btnFrame_Click(object sender, EventArgs e)
        {
            // 0 <= nValue < nMaxFrame
            nValue = this.ntxbValue.IntValue;
            if (nValue < 0 || nMaxFrame <= nValue)
            {
                this.lblMsg.Text = "错误：输入的帧数超出范围。";
                this.lblMsg.Visible = true;
                this.ntxbValue.Focus();
            }
            //必须在文件索引生成之后才能调用，PlayM4_SetFileRefCallBack;
            if (bFileRefCreated)
                HikPlayer.PlayM4_SetCurrentFrameNum(nPort, nValue);
            else
            {
                this.lblMsg.Text = "错误：未创建文件索引。";
                this.lblMsg.Visible = true;
            }
        }

        private void btnTime_Click(object sender, EventArgs e)
        {
            // 0 <= nValue <= nMaxTime
            nValue = this.ntxbValue.IntValue;
            if (nMaxTime < nValue)
            {
                this.lblMsg.Text = "错误：输入的时间超出范围。";
                this.lblMsg.Visible = true;
                this.ntxbValue.Focus();
            }
            HikPlayer.PlayM4_SetPlayedTimeEx(nPort, nValue * 1000);
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void ntxbValue_TextChanged(object sender, EventArgs e)
        {
            this.lblMsg.Visible = false;
        }
    }
}
