using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Runtime.InteropServices;

namespace NHikPlayer
{
    /// <summary>
    /// ״̬
    /// </summary>
    public enum VIDEO_PLAY_STATE
    {
        State_Close = 0,
        State_Play = 1,
        State_Pause = 2,
        State_Stop = 3
    }

    /// <summary>
	/// FormMain ժҪ˵
	/// </summary>
	public class FormMain : System.Windows.Forms.Form
	{
		#region ɵı
        private System.Windows.Forms.Panel pVideo;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItemFileSplit1;
        private System.Windows.Forms.MenuItem menuItemViewSplit1;
		private System.Windows.Forms.MenuItem menuItemViewSplit3;
		private System.Windows.Forms.MenuItem menuItemControlSplit2;
		private System.Windows.Forms.MenuItem menuItemOptionSplit1;
		private System.Windows.Forms.MenuItem menuItemOptionSplit2;
		private System.Windows.Forms.MenuItem menuItemFile;
		private System.Windows.Forms.MenuItem menuItemView;
		private System.Windows.Forms.MenuItem menuItemControl;
		private System.Windows.Forms.MenuItem menuItemOption;
		private System.Windows.Forms.MenuItem menuItemHelp;
		private System.Windows.Forms.MenuItem menuItemOpen;
		private System.Windows.Forms.MenuItem menuItemClose;
		private System.Windows.Forms.MenuItem menuItemExit;
		private System.Windows.Forms.MenuItem menuItemFullscreen;
		private System.Windows.Forms.MenuItem menuItemZoom;
		private System.Windows.Forms.MenuItem menuItem50p;
		private System.Windows.Forms.MenuItem menuItem100p;
		private System.Windows.Forms.MenuItem menuItem200p;
		private System.Windows.Forms.MenuItem menuItemInfo;
		private System.Windows.Forms.MenuItem menuItemRegion;
		private System.Windows.Forms.MenuItem menuItemDevice;
		private System.Windows.Forms.MenuItem menuItemPlayOrPause;
		private System.Windows.Forms.MenuItem menuItemStop;
		private System.Windows.Forms.MenuItem menuItemStepBackward;
		private System.Windows.Forms.MenuItem menuItemStepForward;
		private System.Windows.Forms.MenuItem menuItemFirst;
		private System.Windows.Forms.MenuItem menuItemLast;
		private System.Windows.Forms.MenuItem menuItemLocation;
		private System.Windows.Forms.MenuItem menuItemSetting;
		private System.Windows.Forms.MenuItem menuItemSaveFormat;
		private System.Windows.Forms.MenuItem menuItemSavePath;
		private System.Windows.Forms.MenuItem menuItemBMP;
		private System.Windows.Forms.MenuItem menuItemJPG;
		private System.Windows.Forms.MenuItem menuItemDeflash;
		private System.Windows.Forms.MenuItem menuItemHighQuality;
		private System.Windows.Forms.MenuItem menuItemThrowBFrame;
		private System.Windows.Forms.MenuItem menuItemThrowBFrame0;
		private System.Windows.Forms.MenuItem menuItemThrowBFrame1;
		private System.Windows.Forms.MenuItem menuItemThrowBFrame2;
		private System.Windows.Forms.MenuItem menuItemDisplay;
		private System.Windows.Forms.MenuItem menuItemTimer;
		private System.Windows.Forms.MenuItem menuItemResetBuffer;
		private System.Windows.Forms.MenuItem menuItemDisplayNormal;
		private System.Windows.Forms.MenuItem menuItemDisplayQuarter;
		private System.Windows.Forms.MenuItem menuItemTimer_1;
		private System.Windows.Forms.MenuItem menuItemTimer_2;
		private System.Windows.Forms.MenuItem menuItemManual;
        private System.Windows.Forms.MenuItem menuItemAbout;
        private MenuItem menuItemControlSplit1;
        private Label lblName;
        private Panel pInfo;
        private ColorSlider cSliderTime;
        private ToolStrip toolStrip1;
        private ToolStripButton tsbtnPlayOrPause;
        private ToolStripButton tsbtnStop;
        private ToolStripSeparator toolStripSeparator11;
        private ToolStripButton tsbtnSlow;
        public ToolStripButton tsbtnRestoreSpeed;
        private ToolStripButton tsbtnFast;
        private ToolStripSeparator toolStripSeparator12;
        private ToolStripButton tsbtnMode;
        private ToolStripButton tsbtnOpen;
        private ToolStripButton tsbtnFullscreen;
        private MenuItem menuItemRepeatPlay;
        private StatusStrip statusStrip1;
        private ToolStripColorSlider cSliderVolume;
        private ToolStripButton tsbtnVolume;
        private ToolStripLabel tslblSpace;
        private Timer timer1;
        private ToolStripStatusLabel tsslblTime;
        private ToolStripStatusLabel tsslblSpeed;
        private ToolStripButton tsbtnStepBackward;
        private ToolStripButton tsbtnStepForward;
        private ToolStripStatusLabel tsslblFrame;
        private ToolStripStatusLabel tsslblStatus;
        private ToolStripButton tsbtnCappic;
        private Label lblVersion;
        private ToolStripSeparator toolStripSeparator13;
        private MenuItem menuItemTopMost;
        private MenuItem menuItemTopMostNever;
        private MenuItem menuItemTopMostAlways;
		private System.ComponentModel.IContainer components;

		public FormMain()
		{
			//
			// Windows ֧
			//
			InitializeComponent();

			//
			// TODO:  InitializeComponent úκι캯
			//
		}

		/// <summary>
		/// ʹõԴ
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows ɵĴ
		/// <summary>
		/// ֧ķ - Ҫʹô༭޸
		/// ˷ݡ
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(FormMain));
            this.pVideo = new System.Windows.Forms.Panel();
            this.pInfo = new System.Windows.Forms.Panel();
            this.lblName = new System.Windows.Forms.Label();
            this.lblVersion = new System.Windows.Forms.Label();
            this.mainMenu1 = new System.Windows.Forms.MainMenu(this.components);
            this.menuItemFile = new System.Windows.Forms.MenuItem();
            this.menuItemOpen = new System.Windows.Forms.MenuItem();
            this.menuItemClose = new System.Windows.Forms.MenuItem();
            this.menuItemFileSplit1 = new System.Windows.Forms.MenuItem();
            this.menuItemExit = new System.Windows.Forms.MenuItem();
            this.menuItemView = new System.Windows.Forms.MenuItem();
            this.menuItemFullscreen = new System.Windows.Forms.MenuItem();
            this.menuItemZoom = new System.Windows.Forms.MenuItem();
            this.menuItem50p = new System.Windows.Forms.MenuItem();
            this.menuItem100p = new System.Windows.Forms.MenuItem();
            this.menuItem200p = new System.Windows.Forms.MenuItem();
            this.menuItemViewSplit1 = new System.Windows.Forms.MenuItem();
            this.menuItemInfo = new System.Windows.Forms.MenuItem();
            this.menuItemRegion = new System.Windows.Forms.MenuItem();
            this.menuItemViewSplit3 = new System.Windows.Forms.MenuItem();
            this.menuItemTopMost = new System.Windows.Forms.MenuItem();
            this.menuItemTopMostNever = new System.Windows.Forms.MenuItem();
            this.menuItemTopMostAlways = new System.Windows.Forms.MenuItem();
            this.menuItemDevice = new System.Windows.Forms.MenuItem();
            this.menuItemControl = new System.Windows.Forms.MenuItem();
            this.menuItemPlayOrPause = new System.Windows.Forms.MenuItem();
            this.menuItemStop = new System.Windows.Forms.MenuItem();
            this.menuItemControlSplit1 = new System.Windows.Forms.MenuItem();
            this.menuItemStepForward = new System.Windows.Forms.MenuItem();
            this.menuItemStepBackward = new System.Windows.Forms.MenuItem();
            this.menuItemFirst = new System.Windows.Forms.MenuItem();
            this.menuItemLast = new System.Windows.Forms.MenuItem();
            this.menuItemLocation = new System.Windows.Forms.MenuItem();
            this.menuItemControlSplit2 = new System.Windows.Forms.MenuItem();
            this.menuItemRepeatPlay = new System.Windows.Forms.MenuItem();
            this.menuItemSetting = new System.Windows.Forms.MenuItem();
            this.menuItemOption = new System.Windows.Forms.MenuItem();
            this.menuItemSaveFormat = new System.Windows.Forms.MenuItem();
            this.menuItemBMP = new System.Windows.Forms.MenuItem();
            this.menuItemJPG = new System.Windows.Forms.MenuItem();
            this.menuItemSavePath = new System.Windows.Forms.MenuItem();
            this.menuItemOptionSplit1 = new System.Windows.Forms.MenuItem();
            this.menuItemDeflash = new System.Windows.Forms.MenuItem();
            this.menuItemHighQuality = new System.Windows.Forms.MenuItem();
            this.menuItemThrowBFrame = new System.Windows.Forms.MenuItem();
            this.menuItemThrowBFrame0 = new System.Windows.Forms.MenuItem();
            this.menuItemThrowBFrame1 = new System.Windows.Forms.MenuItem();
            this.menuItemThrowBFrame2 = new System.Windows.Forms.MenuItem();
            this.menuItemOptionSplit2 = new System.Windows.Forms.MenuItem();
            this.menuItemDisplay = new System.Windows.Forms.MenuItem();
            this.menuItemDisplayNormal = new System.Windows.Forms.MenuItem();
            this.menuItemDisplayQuarter = new System.Windows.Forms.MenuItem();
            this.menuItemTimer = new System.Windows.Forms.MenuItem();
            this.menuItemTimer_1 = new System.Windows.Forms.MenuItem();
            this.menuItemTimer_2 = new System.Windows.Forms.MenuItem();
            this.menuItemResetBuffer = new System.Windows.Forms.MenuItem();
            this.menuItemHelp = new System.Windows.Forms.MenuItem();
            this.menuItemManual = new System.Windows.Forms.MenuItem();
            this.menuItemAbout = new System.Windows.Forms.MenuItem();
            this.toolStrip1 = new System.Windows.Forms.ToolStrip();
            this.tsbtnOpen = new System.Windows.Forms.ToolStripButton();
            this.tsbtnPlayOrPause = new System.Windows.Forms.ToolStripButton();
            this.tsbtnStop = new System.Windows.Forms.ToolStripButton();
            this.toolStripSeparator11 = new System.Windows.Forms.ToolStripSeparator();
            this.tsbtnSlow = new System.Windows.Forms.ToolStripButton();
            this.tsbtnRestoreSpeed = new System.Windows.Forms.ToolStripButton();
            this.tsbtnFast = new System.Windows.Forms.ToolStripButton();
            this.toolStripSeparator12 = new System.Windows.Forms.ToolStripSeparator();
            this.tsbtnStepBackward = new System.Windows.Forms.ToolStripButton();
            this.tsbtnStepForward = new System.Windows.Forms.ToolStripButton();
            this.toolStripSeparator13 = new System.Windows.Forms.ToolStripSeparator();
            this.tsbtnMode = new System.Windows.Forms.ToolStripButton();
            this.tsbtnFullscreen = new System.Windows.Forms.ToolStripButton();
            this.tslblSpace = new System.Windows.Forms.ToolStripLabel();
            this.cSliderVolume = new NHikPlayer.ToolStripColorSlider();
            this.tsbtnVolume = new System.Windows.Forms.ToolStripButton();
            this.tsbtnCappic = new System.Windows.Forms.ToolStripButton();
            this.statusStrip1 = new System.Windows.Forms.StatusStrip();
            this.tsslblStatus = new System.Windows.Forms.ToolStripStatusLabel();
            this.tsslblSpeed = new System.Windows.Forms.ToolStripStatusLabel();
            this.tsslblFrame = new System.Windows.Forms.ToolStripStatusLabel();
            this.tsslblTime = new System.Windows.Forms.ToolStripStatusLabel();
            this.cSliderTime = new NHikPlayer.ColorSlider();
            this.timer1 = new System.Windows.Forms.Timer(this.components);
            this.pVideo.SuspendLayout();
            this.pInfo.SuspendLayout();
            this.toolStrip1.SuspendLayout();
            this.statusStrip1.SuspendLayout();
            this.SuspendLayout();
            // 
            // pVideo
            // 
            this.pVideo.BackColor = System.Drawing.SystemColors.ControlDarkDark;
            this.pVideo.Controls.Add(this.pInfo);
            this.pVideo.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pVideo.Location = new System.Drawing.Point(0, 0);
            this.pVideo.Name = "pVideo";
            this.pVideo.Size = new System.Drawing.Size(504, 290);
            this.pVideo.TabIndex = 0;
            this.pVideo.DoubleClick += new System.EventHandler(this.pVideo_DoubleClick);
            this.pVideo.DragDrop += new System.Windows.Forms.DragEventHandler(this.pVideo_DragDrop);
            this.pVideo.DragEnter += new System.Windows.Forms.DragEventHandler(this.pVideo_DragEnter);
            this.pVideo.SizeChanged += new System.EventHandler(this.pVideo_SizeChanged);
            // 
            // pInfo
            // 
            this.pInfo.Controls.Add(this.lblName);
            this.pInfo.Controls.Add(this.lblVersion);
            this.pInfo.Location = new System.Drawing.Point(143, 120);
            this.pInfo.Name = "pInfo";
            this.pInfo.Size = new System.Drawing.Size(183, 39);
            this.pInfo.TabIndex = 0;
            // 
            // lblName
            // 
            this.lblName.AutoSize = true;
            this.lblName.Font = new System.Drawing.Font("΢ź", 14.25F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((byte)(134)));
            this.lblName.ForeColor = System.Drawing.SystemColors.AppWorkspace;
            this.lblName.Location = new System.Drawing.Point(8, 6);
            this.lblName.Name = "lblName";
            this.lblName.Size = new System.Drawing.Size(120, 26);
            this.lblName.TabIndex = 0;
            this.lblName.Text = "NHikPlayer";
            // 
            // lblVersion
            // 
            this.lblVersion.AutoSize = true;
            this.lblVersion.Font = new System.Drawing.Font("΢ź", 9F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((byte)(134)));
            this.lblVersion.ForeColor = System.Drawing.SystemColors.AppWorkspace;
            this.lblVersion.Location = new System.Drawing.Point(123, 13);
            this.lblVersion.Name = "lblVersion";
            this.lblVersion.Size = new System.Drawing.Size(56, 17);
            this.lblVersion.TabIndex = 1;
            this.lblVersion.Text = "1.0 beta";
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItemFile,
            this.menuItemView,
            this.menuItemControl,
            this.menuItemOption,
            this.menuItemHelp});
            // 
            // menuItemFile
            // 
            this.menuItemFile.Index = 0;
            this.menuItemFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItemOpen,
            this.menuItemClose,
            this.menuItemFileSplit1,
            this.menuItemExit});
            this.menuItemFile.Text = "ļ(&F)";
            // 
            // menuItemOpen
            // 
            this.menuItemOpen.Index = 0;
            this.menuItemOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
            this.menuItemOpen.Text = "(&O)...";
            this.menuItemOpen.Click += new System.EventHandler(this.menuItemOpen_Click);
            // 
            // menuItemClose
            // 
            this.menuItemClose.Index = 1;
            this.menuItemClose.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
            this.menuItemClose.Text = "ر(&C)";
            this.menuItemClose.Click += new System.EventHandler(this.menuItemClose_Click);
            // 
            // menuItemFileSplit1
            // 
            this.menuItemFileSplit1.Index = 2;
            this.menuItemFileSplit1.Text = "-";
            // 
            // menuItemExit
            // 
            this.menuItemExit.Index = 3;
            this.menuItemExit.Text = "˳(&X)";
            this.menuItemExit.Click += new System.EventHandler(this.menuItemExit_Click);
            // 
            // menuItemView
            // 
            this.menuItemView.Index = 1;
            this.menuItemView.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItemFullscreen,
            this.menuItemZoom,
            this.menuItemViewSplit1,
            this.menuItemInfo,
            this.menuItemRegion,
            this.menuItemViewSplit3,
            this.menuItemTopMost,
            this.menuItemDevice});
            this.menuItemView.Text = "ͼ(&V)";
            // 
            // menuItemFullscreen
            // 
            this.menuItemFullscreen.Index = 0;
            this.menuItemFullscreen.Shortcut = System.Windows.Forms.Shortcut.F2;
            this.menuItemFullscreen.Text = "ȫ(&F)";
            this.menuItemFullscreen.Click += new System.EventHandler(this.menuItemFullscreen_Click);
            // 
            // menuItemZoom
            // 
            this.menuItemZoom.Index = 1;
            this.menuItemZoom.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem50p,
            this.menuItem100p,
            this.menuItem200p});
            this.menuItemZoom.Text = "ƵС(&Z)";
            // 
            // menuItem50p
            // 
            this.menuItem50p.Index = 0;
            this.menuItem50p.Shortcut = System.Windows.Forms.Shortcut.Alt1;
            this.menuItem50p.Text = "50%";
            this.menuItem50p.Click += new System.EventHandler(this.menuItem50p_Click);
            // 
            // menuItem100p
            // 
            this.menuItem100p.Checked = true;
            this.menuItem100p.Index = 1;
            this.menuItem100p.Shortcut = System.Windows.Forms.Shortcut.Alt2;
            this.menuItem100p.Text = "100%";
            this.menuItem100p.Click += new System.EventHandler(this.menuItem100p_Click);
            // 
            // menuItem200p
            // 
            this.menuItem200p.Index = 2;
            this.menuItem200p.Shortcut = System.Windows.Forms.Shortcut.Alt3;
            this.menuItem200p.Text = "200%";
            this.menuItem200p.Click += new System.EventHandler(this.menuItem200p_Click);
            // 
            // menuItemViewSplit1
            // 
            this.menuItemViewSplit1.Index = 2;
            this.menuItemViewSplit1.Text = "-";
            // 
            // menuItemInfo
            // 
            this.menuItemInfo.Index = 3;
            this.menuItemInfo.Text = "ͳϢ(&I)...";
            this.menuItemInfo.Click += new System.EventHandler(this.menuItemInfo_Click);
            // 
            // menuItemRegion
            // 
            this.menuItemRegion.Index = 4;
            this.menuItemRegion.Text = "ʾ(&R)...";
            this.menuItemRegion.Click += new System.EventHandler(this.menuItemRegion_Click);
            // 
            // menuItemViewSplit3
            // 
            this.menuItemViewSplit3.Index = 5;
            this.menuItemViewSplit3.Text = "-";
            // 
            // menuItemTopMost
            // 
            this.menuItemTopMost.Index = 6;
            this.menuItemTopMost.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItemTopMostNever,
            this.menuItemTopMostAlways});
            this.menuItemTopMost.Text = "ǰʾ(&T)";
            // 
            // menuItemTopMostNever
            // 
            this.menuItemTopMostNever.Checked = true;
            this.menuItemTopMostNever.Index = 0;
            this.menuItemTopMostNever.Text = "Ӳ(&N)";
            this.menuItemTopMostNever.Click += new System.EventHandler(this.menuItemTopMostNever_Click);
            // 
            // menuItemTopMostAlways
            // 
            this.menuItemTopMostAlways.Index = 1;
            this.menuItemTopMostAlways.Text = "ʼ(&A)";
            this.menuItemTopMostAlways.Click += new System.EventHandler(this.menuItemTopMostAlways_Click);
            // 
            // menuItemDevice
            // 
            this.menuItemDevice.Index = 7;
            this.menuItemDevice.Text = "ʾ豸(&D)";
            // 
            // menuItemControl
            // 
            this.menuItemControl.Index = 2;
            this.menuItemControl.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItemPlayOrPause,
            this.menuItemStop,
            this.menuItemControlSplit1,
            this.menuItemStepForward,
            this.menuItemStepBackward,
            this.menuItemFirst,
            this.menuItemLast,
            this.menuItemLocation,
            this.menuItemControlSplit2,
            this.menuItemRepeatPlay,
            this.menuItemSetting});
            this.menuItemControl.Text = "(&C)";
            // 
            // menuItemPlayOrPause
            // 
            this.menuItemPlayOrPause.Index = 0;
            this.menuItemPlayOrPause.Shortcut = System.Windows.Forms.Shortcut.CtrlP;
            this.menuItemPlayOrPause.Text = "/ͣ(&P)";
            this.menuItemPlayOrPause.Click += new System.EventHandler(this.menuItemPlayOrPause_Click);
            // 
            // menuItemStop
            // 
            this.menuItemStop.Index = 1;
            this.menuItemStop.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
            this.menuItemStop.Text = "ֹͣ(&S)";
            this.menuItemStop.Click += new System.EventHandler(this.menuItemStop_Click);
            // 
            // menuItemControlSplit1
            // 
            this.menuItemControlSplit1.Index = 2;
            this.menuItemControlSplit1.Text = "-";
            // 
            // menuItemStepForward
            // 
            this.menuItemStepForward.Index = 3;
            this.menuItemStepForward.Shortcut = System.Windows.Forms.Shortcut.CtrlF;
            this.menuItemStepForward.Text = "֡(&F)";
            this.menuItemStepForward.Click += new System.EventHandler(this.menuItemStepForward_Click);
            // 
            // menuItemStepBackward
            // 
            this.menuItemStepBackward.Index = 4;
            this.menuItemStepBackward.Shortcut = System.Windows.Forms.Shortcut.CtrlB;
            this.menuItemStepBackward.Text = "֡(&B)";
            this.menuItemStepBackward.Click += new System.EventHandler(this.menuItemStepBackward_Click);
            // 
            // menuItemFirst
            // 
            this.menuItemFirst.Index = 5;
            this.menuItemFirst.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftF;
            this.menuItemFirst.Text = "һ֡(&S)";
            this.menuItemFirst.Click += new System.EventHandler(this.menuItemFirst_Click);
            // 
            // menuItemLast
            // 
            this.menuItemLast.Index = 6;
            this.menuItemLast.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftL;
            this.menuItemLast.Text = "ĩ֡(&E)";
            this.menuItemLast.Click += new System.EventHandler(this.menuItemLast_Click);
            // 
            // menuItemLocation
            // 
            this.menuItemLocation.Index = 7;
            this.menuItemLocation.Shortcut = System.Windows.Forms.Shortcut.CtrlL;
            this.menuItemLocation.Text = "λ(&L)...";
            this.menuItemLocation.Click += new System.EventHandler(this.menuItemLocation_Click);
            // 
            // menuItemControlSplit2
            // 
            this.menuItemControlSplit2.Index = 8;
            this.menuItemControlSplit2.Text = "-";
            // 
            // menuItemRepeatPlay
            // 
            this.menuItemRepeatPlay.Enabled = false;
            this.menuItemRepeatPlay.Index = 9;
            this.menuItemRepeatPlay.Text = "ѭ(&R)";
            this.menuItemRepeatPlay.Click += new System.EventHandler(this.menuItemRepeatPlay_Click);
            // 
            // menuItemSetting
            // 
            this.menuItemSetting.Index = 10;
            this.menuItemSetting.Shortcut = System.Windows.Forms.Shortcut.CtrlV;
            this.menuItemSetting.Text = "ʾ(&C)...";
            this.menuItemSetting.Click += new System.EventHandler(this.menuItemSetting_Click);
            // 
            // menuItemOption
            // 
            this.menuItemOption.Index = 3;
            this.menuItemOption.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItemSaveFormat,
            this.menuItemSavePath,
            this.menuItemOptionSplit1,
            this.menuItemDeflash,
            this.menuItemHighQuality,
            this.menuItemThrowBFrame,
            this.menuItemOptionSplit2,
            this.menuItemDisplay,
            this.menuItemTimer,
            this.menuItemResetBuffer});
            this.menuItemOption.Text = "ѡ(&P)";
            // 
            // menuItemSaveFormat
            // 
            this.menuItemSaveFormat.Enabled = false;
            this.menuItemSaveFormat.Index = 0;
            this.menuItemSaveFormat.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItemBMP,
            this.menuItemJPG});
            this.menuItemSaveFormat.Text = "ץͼʽ(&C)";
            // 
            // menuItemBMP
            // 
            this.menuItemBMP.Checked = true;
            this.menuItemBMP.Index = 0;
            this.menuItemBMP.Text = "BMP";
            this.menuItemBMP.Click += new System.EventHandler(this.menuItemBMP_Click);
            // 
            // menuItemJPG
            // 
            this.menuItemJPG.Index = 1;
            this.menuItemJPG.Text = "JPG";
            this.menuItemJPG.Click += new System.EventHandler(this.menuItemJPG_Click);
            // 
            // menuItemSavePath
            // 
            this.menuItemSavePath.Enabled = false;
            this.menuItemSavePath.Index = 1;
            this.menuItemSavePath.Text = "ñ·(&P)...";
            this.menuItemSavePath.Click += new System.EventHandler(this.menuItemSavePath_Click);
            // 
            // menuItemOptionSplit1
            // 
            this.menuItemOptionSplit1.Index = 2;
            this.menuItemOptionSplit1.Text = "-";
            // 
            // menuItemDeflash
            // 
            this.menuItemDeflash.Checked = true;
            this.menuItemDeflash.Index = 3;
            this.menuItemDeflash.Text = "ȥ˸(&F)";
            this.menuItemDeflash.Click += new System.EventHandler(this.menuItemDeflash_Click);
            // 
            // menuItemHighQuality
            // 
            this.menuItemHighQuality.Checked = true;
            this.menuItemHighQuality.Index = 4;
            this.menuItemHighQuality.Text = "ͼ(&Q)";
            this.menuItemHighQuality.Click += new System.EventHandler(this.menuItemHighQuality_Click);
            // 
            // menuItemThrowBFrame
            // 
            this.menuItemThrowBFrame.Index = 5;
            this.menuItemThrowBFrame.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItemThrowBFrame0,
            this.menuItemThrowBFrame1,
            this.menuItemThrowBFrame2});
            this.menuItemThrowBFrame.Text = "B֡(&B)";
            // 
            // menuItemThrowBFrame0
            // 
            this.menuItemThrowBFrame0.Checked = true;
            this.menuItemThrowBFrame0.Index = 0;
            this.menuItemThrowBFrame0.Text = "";
            this.menuItemThrowBFrame0.Click += new System.EventHandler(this.menuItemThrowBFrame0_Click);
            // 
            // menuItemThrowBFrame1
            // 
            this.menuItemThrowBFrame1.Index = 1;
            this.menuItemThrowBFrame1.Text = "һ֡";
            this.menuItemThrowBFrame1.Click += new System.EventHandler(this.menuItemThrowBFrame1_Click);
            // 
            // menuItemThrowBFrame2
            // 
            this.menuItemThrowBFrame2.Index = 2;
            this.menuItemThrowBFrame2.Text = "֡";
            this.menuItemThrowBFrame2.Click += new System.EventHandler(this.menuItemThrowBFrame2_Click);
            // 
            // menuItemOptionSplit2
            // 
            this.menuItemOptionSplit2.Index = 6;
            this.menuItemOptionSplit2.Text = "-";
            // 
            // menuItemDisplay
            // 
            this.menuItemDisplay.Index = 7;
            this.menuItemDisplay.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItemDisplayNormal,
            this.menuItemDisplayQuarter});
            this.menuItemDisplay.Text = "ʾʽ(&D)";
            // 
            // menuItemDisplayNormal
            // 
            this.menuItemDisplayNormal.Checked = true;
            this.menuItemDisplayNormal.Index = 0;
            this.menuItemDisplayNormal.Text = "";
            this.menuItemDisplayNormal.Click += new System.EventHandler(this.menuItemDisplayNormal_Click);
            // 
            // menuItemDisplayQuarter
            // 
            this.menuItemDisplayQuarter.Index = 1;
            this.menuItemDisplayQuarter.Text = "";
            this.menuItemDisplayQuarter.Click += new System.EventHandler(this.menuItemDisplayQuarter_Click);
            // 
            // menuItemTimer
            // 
            this.menuItemTimer.Index = 8;
            this.menuItemTimer.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItemTimer_1,
            this.menuItemTimer_2});
            this.menuItemTimer.Text = "ѡʱ(&T)";
            // 
            // menuItemTimer_1
            // 
            this.menuItemTimer_1.Checked = true;
            this.menuItemTimer_1.Index = 0;
            this.menuItemTimer_1.Text = "Timer_1";
            this.menuItemTimer_1.Click += new System.EventHandler(this.menuItemTimer_1_Click);
            // 
            // menuItemTimer_2
            // 
            this.menuItemTimer_2.Index = 1;
            this.menuItemTimer_2.Text = "Timer_2";
            this.menuItemTimer_2.Click += new System.EventHandler(this.menuItemTimer_2_Click);
            // 
            // menuItemResetBuffer
            // 
            this.menuItemResetBuffer.Index = 9;
            this.menuItemResetBuffer.Text = "û(&R)";
            this.menuItemResetBuffer.Click += new System.EventHandler(this.menuItemResetBuffer_Click);
            // 
            // menuItemHelp
            // 
            this.menuItemHelp.Index = 4;
            this.menuItemHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItemManual,
            this.menuItemAbout});
            this.menuItemHelp.Text = "(&H)";
            // 
            // menuItemManual
            // 
            this.menuItemManual.Index = 0;
            this.menuItemManual.Shortcut = System.Windows.Forms.Shortcut.F1;
            this.menuItemManual.Text = "(&H)";
            this.menuItemManual.Click += new System.EventHandler(this.menuItemManual_Click);
            // 
            // menuItemAbout
            // 
            this.menuItemAbout.Index = 1;
            this.menuItemAbout.Text = "(&A)";
            this.menuItemAbout.Click += new System.EventHandler(this.menuItemAbout_Click);
            // 
            // toolStrip1
            // 
            this.toolStrip1.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.toolStrip1.GripStyle = System.Windows.Forms.ToolStripGripStyle.Hidden;
            this.toolStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.tsbtnOpen,
            this.tsbtnPlayOrPause,
            this.tsbtnStop,
            this.toolStripSeparator11,
            this.tsbtnSlow,
            this.tsbtnRestoreSpeed,
            this.tsbtnFast,
            this.toolStripSeparator12,
            this.tsbtnStepBackward,
            this.tsbtnStepForward,
            this.toolStripSeparator13,
            this.tsbtnMode,
            this.tsbtnFullscreen,
            this.tslblSpace,
            this.cSliderVolume,
            this.tsbtnVolume,
            this.tsbtnCappic});
            this.toolStrip1.Location = new System.Drawing.Point(0, 313);
            this.toolStrip1.Name = "toolStrip1";
            this.toolStrip1.Size = new System.Drawing.Size(504, 25);
            this.toolStrip1.TabIndex = 2;
            this.toolStrip1.Text = "toolStrip1";
            // 
            // tsbtnOpen
            // 
            this.tsbtnOpen.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.tsbtnOpen.Image = global::NHikPlayer.Properties.Resources.Open;
            this.tsbtnOpen.Name = "tsbtnOpen";
            this.tsbtnOpen.Size = new System.Drawing.Size(23, 22);
            this.tsbtnOpen.Text = "toolStripButton1";
            this.tsbtnOpen.ToolTipText = "ļ";
            this.tsbtnOpen.Click += new System.EventHandler(this.tsbtnOpen_Click);
            // 
            // tsbtnPlayOrPause
            // 
            this.tsbtnPlayOrPause.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.tsbtnPlayOrPause.Image = global::NHikPlayer.Properties.Resources.Play;
            this.tsbtnPlayOrPause.Name = "tsbtnPlayOrPause";
            this.tsbtnPlayOrPause.Size = new System.Drawing.Size(23, 22);
            this.tsbtnPlayOrPause.Text = "toolStripButton2";
            this.tsbtnPlayOrPause.ToolTipText = "";
            this.tsbtnPlayOrPause.Click += new System.EventHandler(this.tsbtnPlayOrPause_Click);
            // 
            // tsbtnStop
            // 
            this.tsbtnStop.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.tsbtnStop.Image = global::NHikPlayer.Properties.Resources.Stop;
            this.tsbtnStop.Name = "tsbtnStop";
            this.tsbtnStop.Size = new System.Drawing.Size(23, 22);
            this.tsbtnStop.Text = "toolStripButton3";
            this.tsbtnStop.ToolTipText = "ֹͣ";
            this.tsbtnStop.Click += new System.EventHandler(this.tsbtnStop_Click);
            // 
            // toolStripSeparator11
            // 
            this.toolStripSeparator11.Name = "toolStripSeparator11";
            this.toolStripSeparator11.Size = new System.Drawing.Size(6, 25);
            // 
            // tsbtnSlow
            // 
            this.tsbtnSlow.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.tsbtnSlow.Image = global::NHikPlayer.Properties.Resources.Slowdown;
            this.tsbtnSlow.Name = "tsbtnSlow";
            this.tsbtnSlow.Size = new System.Drawing.Size(23, 22);
            this.tsbtnSlow.Text = "toolStripButton5";
            this.tsbtnSlow.ToolTipText = "";
            this.tsbtnSlow.Click += new System.EventHandler(this.tsbtnSlow_Click);
            // 
            // tsbtnRestoreSpeed
            // 
            this.tsbtnRestoreSpeed.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.tsbtnRestoreSpeed.Image = global::NHikPlayer.Properties.Resources.Restorespeed;
            this.tsbtnRestoreSpeed.Name = "tsbtnRestoreSpeed";
            this.tsbtnRestoreSpeed.Size = new System.Drawing.Size(23, 22);
            this.tsbtnRestoreSpeed.Text = "toolStripButton6";
            this.tsbtnRestoreSpeed.ToolTipText = "ԭʼٶ";
            this.tsbtnRestoreSpeed.Click += new System.EventHandler(this.tsbtnRestoreSpeed_Click);
            // 
            // tsbtnFast
            // 
            this.tsbtnFast.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.tsbtnFast.Image = global::NHikPlayer.Properties.Resources.Speedup;
            this.tsbtnFast.Name = "tsbtnFast";
            this.tsbtnFast.Size = new System.Drawing.Size(23, 22);
            this.tsbtnFast.Text = "toolStripButton7";
            this.tsbtnFast.ToolTipText = "";
            this.tsbtnFast.Click += new System.EventHandler(this.tsbtnFast_Click);
            // 
            // toolStripSeparator12
            // 
            this.toolStripSeparator12.Name = "toolStripSeparator12";
            this.toolStripSeparator12.Size = new System.Drawing.Size(6, 25);
            // 
            // tsbtnStepBackward
            // 
            this.tsbtnStepBackward.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.tsbtnStepBackward.Image = global::NHikPlayer.Properties.Resources.StepBackward;
            this.tsbtnStepBackward.Name = "tsbtnStepBackward";
            this.tsbtnStepBackward.Size = new System.Drawing.Size(23, 22);
            this.tsbtnStepBackward.Text = "toolStripButton4";
            this.tsbtnStepBackward.ToolTipText = "";
            this.tsbtnStepBackward.Click += new System.EventHandler(this.tsbtnStepBackward_Click);
            // 
            // tsbtnStepForward
            // 
            this.tsbtnStepForward.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.tsbtnStepForward.Image = global::NHikPlayer.Properties.Resources.StepForward;
            this.tsbtnStepForward.Name = "tsbtnStepForward";
            this.tsbtnStepForward.Size = new System.Drawing.Size(23, 22);
            this.tsbtnStepForward.Text = "toolStripButton8";
            this.tsbtnStepForward.ToolTipText = "";
            this.tsbtnStepForward.Click += new System.EventHandler(this.tsbtnStepForward_Click);
            // 
            // toolStripSeparator13
            // 
            this.toolStripSeparator13.Name = "toolStripSeparator13";
            this.toolStripSeparator13.Size = new System.Drawing.Size(6, 25);
            // 
            // tsbtnMode
            // 
            this.tsbtnMode.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.tsbtnMode.Enabled = false;
            this.tsbtnMode.Image = ((System.Drawing.Image)(resources.GetObject("tsbtnMode.Image")));
            this.tsbtnMode.Name = "tsbtnMode";
            this.tsbtnMode.Size = new System.Drawing.Size(23, 22);
            this.tsbtnMode.Text = "toolStripButton9";
            this.tsbtnMode.ToolTipText = "ѭģʽ";
            this.tsbtnMode.Click += new System.EventHandler(this.tsbtnMode_Click);
            // 
            // tsbtnFullscreen
            // 
            this.tsbtnFullscreen.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.tsbtnFullscreen.Image = global::NHikPlayer.Properties.Resources.Fullscreen;
            this.tsbtnFullscreen.Name = "tsbtnFullscreen";
            this.tsbtnFullscreen.Size = new System.Drawing.Size(23, 22);
            this.tsbtnFullscreen.Text = "toolStripButton10";
            this.tsbtnFullscreen.ToolTipText = "ȫ";
            this.tsbtnFullscreen.Click += new System.EventHandler(this.tsbtnFullscreen_Click);
            // 
            // tslblSpace
            // 
            this.tslblSpace.Alignment = System.Windows.Forms.ToolStripItemAlignment.Right;
            this.tslblSpace.Name = "tslblSpace";
            this.tslblSpace.Size = new System.Drawing.Size(12, 22);
            this.tslblSpace.Text = " ";
            // 
            // cSliderVolume
            // 
            this.cSliderVolume.Alignment = System.Windows.Forms.ToolStripItemAlignment.Right;
            this.cSliderVolume.AutoSize = false;
            this.cSliderVolume.BackColor = System.Drawing.Color.Transparent;
            this.cSliderVolume.Name = "cSliderVolume";
            this.cSliderVolume.Size = new System.Drawing.Size(90, 18);
            this.cSliderVolume.Value = 0;
            this.cSliderVolume.Scroll += new System.Windows.Forms.ScrollEventHandler(this.cSliderVolume_Scroll);
            // 
            // tsbtnVolume
            // 
            this.tsbtnVolume.Alignment = System.Windows.Forms.ToolStripItemAlignment.Right;
            this.tsbtnVolume.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.tsbtnVolume.Image = global::NHikPlayer.Properties.Resources.Volume;
            this.tsbtnVolume.Name = "tsbtnVolume";
            this.tsbtnVolume.Size = new System.Drawing.Size(23, 22);
            this.tsbtnVolume.Text = "toolStripButton12";
            this.tsbtnVolume.ToolTipText = "";
            this.tsbtnVolume.Click += new System.EventHandler(this.tsbtnVolume_Click);
            // 
            // tsbtnCappic
            // 
            this.tsbtnCappic.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.tsbtnCappic.Enabled = false;
            this.tsbtnCappic.Image = global::NHikPlayer.Properties.Resources.Cappic;
            this.tsbtnCappic.ImageTransparentColor = System.Drawing.Color.Magenta;
            this.tsbtnCappic.Name = "tsbtnCappic";
            this.tsbtnCappic.Size = new System.Drawing.Size(23, 22);
            this.tsbtnCappic.Text = "toolStripButton11";
            this.tsbtnCappic.ToolTipText = "׽";
            this.tsbtnCappic.Click += new System.EventHandler(this.tsbtnCappic_Click);
            // 
            // statusStrip1
            // 
            this.statusStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.tsslblStatus,
            this.tsslblSpeed,
            this.tsslblFrame,
            this.tsslblTime});
            this.statusStrip1.Location = new System.Drawing.Point(0, 338);
            this.statusStrip1.Name = "statusStrip1";
            this.statusStrip1.Size = new System.Drawing.Size(504, 22);
            this.statusStrip1.TabIndex = 3;
            this.statusStrip1.Text = "statusStrip1";
            // 
            // tsslblStatus
            // 
            this.tsslblStatus.AutoSize = false;
            this.tsslblStatus.Name = "tsslblStatus";
            this.tsslblStatus.Size = new System.Drawing.Size(50, 17);
            this.tsslblStatus.Text = "";
            this.tsslblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // tsslblSpeed
            // 
            this.tsslblSpeed.AutoSize = false;
            this.tsslblSpeed.Name = "tsslblSpeed";
            this.tsslblSpeed.Size = new System.Drawing.Size(60, 17);
            this.tsslblSpeed.Text = "ٶ X1";
            this.tsslblSpeed.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // tsslblFrame
            // 
            this.tsslblFrame.Name = "tsslblFrame";
            this.tsslblFrame.Size = new System.Drawing.Size(199, 17);
            this.tsslblFrame.Spring = true;
            this.tsslblFrame.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // tsslblTime
            // 
            this.tsslblTime.AutoSize = false;
            this.tsslblTime.Name = "tsslblTime";
            this.tsslblTime.Size = new System.Drawing.Size(180, 17);
            this.tsslblTime.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // cSliderTime
            // 
            this.cSliderTime.BackColor = System.Drawing.Color.Transparent;
            this.cSliderTime.BarInnerColor = System.Drawing.Color.FromArgb(((int)(((byte)(229)))), ((int)(((byte)(229)))), ((int)(((byte)(229)))));
            this.cSliderTime.BarOuterColor = System.Drawing.Color.FromArgb(((int)(((byte)(193)))), ((int)(((byte)(193)))), ((int)(((byte)(193)))));
            this.cSliderTime.BarPenColor = System.Drawing.Color.FromArgb(((int)(((byte)(243)))), ((int)(((byte)(243)))), ((int)(((byte)(243)))));
            this.cSliderTime.BorderRoundRectSize = new System.Drawing.Size(8, 8);
            this.cSliderTime.ColorSchema = NHikPlayer.ColorSlider.ColorSchemas.PerlNHikPlayer;
            this.cSliderTime.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.cSliderTime.DrawFocusRectangle = false;
            this.cSliderTime.ElapsedInnerColor = System.Drawing.Color.FromArgb(((int)(((byte)(174)))), ((int)(((byte)(200)))), ((int)(((byte)(228)))));
            this.cSliderTime.ElapsedOuterColor = System.Drawing.Color.FromArgb(((int)(((byte)(52)))), ((int)(((byte)(101)))), ((int)(((byte)(164)))));
            this.cSliderTime.LargeChange = ((uint)(5u));
            this.cSliderTime.Location = new System.Drawing.Point(0, 290);
            this.cSliderTime.MouseEffects = false;
            this.cSliderTime.Name = "cSliderTime";
            this.cSliderTime.Size = new System.Drawing.Size(504, 23);
            this.cSliderTime.SmallChange = ((uint)(1u));
            this.cSliderTime.TabIndex = 1;
            this.cSliderTime.ThumbRoundRectSize = new System.Drawing.Size(15, 15);
            this.cSliderTime.ThumbSize = 12;
            this.cSliderTime.Value = 0;
            this.cSliderTime.Scroll += new System.Windows.Forms.ScrollEventHandler(this.cSliderTime_Scroll);
            // 
            // timer1
            // 
            this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
            // 
            // FormMain
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
            this.ClientSize = new System.Drawing.Size(504, 360);
            this.Controls.Add(this.pVideo);
            this.Controls.Add(this.cSliderTime);
            this.Controls.Add(this.toolStrip1);
            this.Controls.Add(this.statusStrip1);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Menu = this.mainMenu1;
            this.MinimumSize = new System.Drawing.Size(412, 310);
            this.Name = "FormMain";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "NHikPlayer 1.0 beta";
            this.Load += new System.EventHandler(this.FormMain_Load);
            this.DragDrop += new System.Windows.Forms.DragEventHandler(this.pVideo_DragDrop);
            this.DragEnter += new System.Windows.Forms.DragEventHandler(this.pVideo_DragEnter);
            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.FormMain_FormClosing);
            this.pVideo.ResumeLayout(false);
            this.pInfo.ResumeLayout(false);
            this.pInfo.PerformLayout();
            this.toolStrip1.ResumeLayout(false);
            this.toolStrip1.PerformLayout();
            this.statusStrip1.ResumeLayout(false);
            this.statusStrip1.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		#region ˽б
        /*
         * ص쳣(⵽ CallbackOnCollectedDelegate)
         * 
         * 1.ίеñΪԱЧ
         * 2.ʹ GC.KeepAlive ȷضʵֻ״̬һʱ䡣
         * http://www.microsoft.com/china/MSDN/library/netFramework/netframework/issuesBugBash.mspx?mfr=true
         * */
        private DisplayCBFun dcbf;
        private Audio ad;
        private FileRefDone frd;

        // ˿ڣѡΧ015
        private int nPort = 0;
        // Ƶļ(.mp4,.264)·
        private string strPlayFileName = string.Empty;
        // ǰƵ״̬
        private VIDEO_PLAY_STATE enumState;

        // 0ʾΪbmpʽ1ʾΪjpegʽ
        private int nCapPicType = 0;
        // bmp
        private int nBmp = 1;
        // jpeg
        private int nJpeg = 1;
        // ͼƬ·
        private string strCapPicPath = string.Empty;

        // ǷѾļ
        private bool bOpen = false;
        // Ƿ
        private bool bSound = false;
        // Ƿļ  
        private bool bFileRefCreated = false;
        // Ƿȫʾ
        private bool bFullScreen = false;
        // Ƿȥ˸
        private bool bDeflash = true;
        // Ƿʹøͼ
        private bool bPicQuality = true;
        // Ƿѭ
        private bool bRepeatPlay = false;

        // Ƶ
        private int nWidth = 0;
        // Ƶ߶
        private int nHeight = 0;
        // ֡
        private int dwTotalFrames = 0;
        // ʱ
        private int dwMaxFileTime = 0;
        // Ƶٶ
        private int nSpeed = 0;
        // ǰŽ̶
        private int nPrePlayPos = 0;
		#endregion

        #region CallBack
        /// <summary>
        /// ص
        /// </summary>
        /// <param name="nPort">ͨ</param>
        /// <param name="pAudioBuf">waveʽƵ</param>
        /// <param name="nSize">Ƶݳ</param>
        /// <param name="nStamp"> ʱ(ms) </param>
        /// <param name="nType">ƵT_AUDIO16, 16khzÿ16λʾ </param>
        /// <param name="nUser">ûԶ</param>
        public void CB_Audio(int nPort, string pAudioBuf, int nSize, int nStamp, int nType, int nUser)
        {
        }

        /// <summary>
        /// ص˻صãôʾûԼƣʾٶȣ
        /// </summary>
        /// <param name="nPort">ͨ</param>
        /// <param name="pBuf">Ƶ</param>
        /// <param name="nSize">ƵpBufĳ</param>
        /// <param name="pFrameInfo">ͼϢ</param>
        /// <param name="nReserved1"></param>
        /// <param name="nReserved2"></param>
        public static void CB_DecCBFun(int nPort, IntPtr pBuf, int nSize, ref FRAME_INFO pFrameInfo, int nReserved1, int nReserved2)
        {
        }


        /// <summary>
        /// ץͼص
        /// </summary>
        /// <param name="nPort">ͨ</param>
        /// <param name="pBuf">ͼ</param>
        /// <param name="nSize">ͼݴС</param>
        /// <param name="nWidth">λ</param>
        /// <param name="nHeight"></param>
        /// <param name="nStamp">ʱϢλ</param>
        /// <param name="nType">ͣT_YV12T_RGB32T_UYVY</param>
        /// <param name="nReceaved"></param>
        public void CB_DisplayCBFun(int nPort, IntPtr pBuf, int nSize, int nWidth, int nHeight, int nStamp, int nType, int nReceaved)
        {
        }

        /// <summary>
        /// ص
        /// </summary>
        /// <param name="nPort">ͨ</param>
        /// <param name="hDc">hDc OffScreen豸ģʾڿͻDC</param>
        /// <param name="nUser">ûݣû</param>
        public void CB_DrawFun(int nPort, IntPtr hDc, int nUser)
        {

        }

        /// <summary>
        /// ص
        /// </summary>
        /// <param name="nPort">ͨ</param>
        /// <param name="nUser">ûԶ</param>
        public void CB_EncChange(int nPort, int nUser)
        {
        }

        /// <summary>
        /// ļص
        /// </summary>
        /// <param name="nPort">ͨ</param>
        /// <param name="nUser">û</param>
        public void CB_FileRefDone(int nPort, ushort nUser)
        {
            //ļ
            bFileRefCreated = true;
        }

        /// <summary>
        /// ص
        /// </summary>
        /// <param name="nPort">ͨ</param>
        /// <param name="frameType">й֡Ϣ</param>
        /// <param name="nUser"></param>
        public void CB_GetOrignalFrame(int nPort, ref FRAME_TYPE frameType, int nUser)
        {
        }

        /// <summary>
        /// ص
        /// </summary>
        /// <param name="nPort">ͨ</param>
        /// <param name="nBufSize">ʣ</param>
        /// <param name="dwUser">û</param>
        /// <param name="pContext"></param>
        public void CB_SourceBufCallBack(int nPort, ushort nBufSize, ushort dwUser, IntPtr pContext)
        {
        }

        /// <summary>
        /// ص
        /// </summary>
        /// <param name="nPort">ͨ</param>
        /// <param name="pFilePos">ļλ</param>
        /// <param name="bIsVideo">ǷƵݣ1Ƶ0Ƶ</param>
        /// <param name="nUser">û</param>
        public void CB_Verify(int nPort, ref PFRAME_POS pFilePos, ushort bIsVideo, ushort nUser)
        {
        }
        #endregion

        #region Player
        private bool BrowseFile()
        {
            OpenFileDialog opfileDlg = new OpenFileDialog();
            opfileDlg.Filter = "Hikvisionļ(*.mp4;*.264)|*.mp4;*.264|ļ(*.*)|*.*";
            if (opfileDlg.ShowDialog() == DialogResult.OK)
            {
                strPlayFileName = opfileDlg.FileName;
                return true;
            }
            else
            {
                return false;
            }
        }

        private void OpenFile()
        {
            frd = new FileRefDone(CB_FileRefDone);
            HikPlayer.PlayM4_SetFileRefCallBack(nPort, frd, 0);
            GC.KeepAlive(frd);

            //ļ
            HikPlayer.PlayM4_OpenFile(nPort, strPlayFileName);
            //Overlayģʽģʽֻһ·ɵõԿ֧֣ʹOverlayͽ
            HikPlayer.PlayM4_SetOverlayMode(nPort, true, Color.FromArgb(255, 0, 255).ToArgb());

            //ȡƵʱ
            dwMaxFileTime = HikPlayer.PlayM4_GetFileTime(nPort);
            if (dwMaxFileTime == 0)
                return;
            //ȡƵ֡
            dwTotalFrames = HikPlayer.PlayM4_GetFileTotalFrames(nPort);

            bOpen = true;

            //
            Play();
        }

        private void CloseFile()
        {
            //ֹͣ
            Stop();

            HikPlayer.PlayM4_CloseFile(nPort);
            enumState = VIDEO_PLAY_STATE.State_Close;
            bOpen = false;
            bFileRefCreated = false;
        }

        private void Play()
        {
            if (enumState == VIDEO_PLAY_STATE.State_Play)
                return;

            if (enumState == VIDEO_PLAY_STATE.State_Pause)
            {
                int nPreSpeed = nSpeed;
                enumState = VIDEO_PLAY_STATE.State_Play;
                HikPlayer.PlayM4_Pause(nPort, false);
                HikPlayer.PlayM4_Play(nPort, pVideo.Handle);

                nSpeed = 0;
                AdjustSpeed(nPreSpeed);
                ThrowBFrame(0);
            }
            else
            {
                nSpeed = 0;
                ThrowBFrame(0);

                if (HikPlayer.PlayM4_Play(nPort, pVideo.Handle))
                {
                    enumState = VIDEO_PLAY_STATE.State_Play;
                    HikPlayer.PlayM4_RefreshPlay(nPort);
                }
                bSound = HikPlayer.PlayM4_PlaySound(nPort);
            }

            this.timer1.Enabled = true;
            this.pInfo.Visible = false;
            this.tsslblStatus.Text = "";
            this.menuItemTimer.Enabled = false;
            this.tsbtnPlayOrPause.Image = global::NHikPlayer.Properties.Resources.Pause;
        }

        private void Pause()
        {
            if (enumState == VIDEO_PLAY_STATE.State_Play)
            {
                HikPlayer.PlayM4_Pause(nPort, true);
                enumState = VIDEO_PLAY_STATE.State_Pause;
                this.timer1.Enabled = false;
            }
        }

        private void Stop()
        {
            if (enumState == VIDEO_PLAY_STATE.State_Stop)
                return;

            HikPlayer.PlayM4_SetFileEndMsg(nPort, pVideo.Handle, 0);
            if (HikPlayer.PlayM4_StopSound())
            {
                bSound = false;
            }
            if (HikPlayer.PlayM4_Stop(nPort))
            {
            }
            enumState = VIDEO_PLAY_STATE.State_Stop;

            this.timer1.Enabled = false;
            this.cSliderTime.Value = 0;
            this.tsbtnPlayOrPause.Image = global::NHikPlayer.Properties.Resources.Play;
            this.tsslblStatus.Text = "ֹͣ";
            this.menuItemTimer.Enabled = true;
            this.tsslblFrame.Text = string.Empty;
            this.tsslblTime.Text = string.Empty;
            this.pInfo.Left = (this.pVideo.Width - this.pInfo.Width) / 2;
            this.pInfo.Top = (this.pVideo.Height - this.pInfo.Height) / 2;
            this.pInfo.Visible = true;
            this.pVideo.Invalidate(true);
        }

        private void GotoStart()
        {
            if (bFileRefCreated)
                HikPlayer.PlayM4_SetCurrentFrameNum(nPort, 0);
            else
                HikPlayer.PlayM4_SetPlayPos(nPort, 0);
        }

        private void GotoEnd()
        {
            if (bFileRefCreated)
            {
                int nEndFrame = dwTotalFrames;
                int nCurFrame = HikPlayer.PlayM4_GetCurrentFrameNum(nPort);
                while (!HikPlayer.PlayM4_SetCurrentFrameNum(nPort, nEndFrame--))
                {
                    if (nEndFrame <= Math.Max(0, dwTotalFrames - 3))
                    {
                        HikPlayer.PlayM4_SetCurrentFrameNum(nPort, nCurFrame);
                        break;
                    }
                }
            }
            else
            {
                HikPlayer.PlayM4_SetPlayPos(nPort, 1);
            }
        }

        private void Fast()
        {
            if (HikPlayer.PlayM4_Fast(nPort))
            {
                nSpeed++;
                if (nSpeed > 0)
                    ThrowBFrame(2);
            }
        }

        private void Slow()
        {
            if (HikPlayer.PlayM4_Slow(nPort))
            {
                nSpeed--;
                if (nSpeed <= 0)
                    ThrowBFrame(0);
            }
        }

        private void RestoreSpeed()
        {
            if (HikPlayer.PlayM4_Play(nPort, pVideo.Handle))
            {
                nSpeed = 0;
                ThrowBFrame(0);
            }
        }

        private void AdjustSpeed(int aSpeed)
        {
            int nCyc = 0;
            while (nSpeed != aSpeed)
            {
                if (nSpeed > aSpeed)
                    Fast();
                if (nSpeed < aSpeed)
                    Slow();

                nCyc++;
                if (nCyc >= 10)
                    break;
            }
        }

        private void StepForward()
        {
            ThrowBFrame(0);
            HikPlayer.PlayM4_OneByOne(nPort);
            enumState = VIDEO_PLAY_STATE.State_Pause;
        }

        private void StepBackward()
        {
            if (bFileRefCreated)
            {
                HikPlayer.PlayM4_OneByOneBack(nPort);
                enumState = VIDEO_PLAY_STATE.State_Pause;
            }
            else
                MessageBox.Show("δļ", "", MessageBoxButtons.OK);
        }

        private void Cappic()
        {
            string sFilePath = string.Empty;
            int nBufSize = nWidth * nHeight * 3 / 2;
            byte[] pImage = new byte[nBufSize];
            int pImageSize = 0;

            if (nCapPicType == 0)
            {
                if (!HikPlayer.PlayM4_GetBMP(nPort, pImage, nBufSize, out pImageSize))
                {
                    int code = HikPlayer.PlayM4_GetLastError(nPort);
                    return;
                }

                if (strCapPicPath.Length < 0)
                    strCapPicPath = Application.StartupPath;

                sFilePath = string.Format(@"{0}\capture{1:00}.bmp", strCapPicPath, nBmp);
                nBmp++;
                
            }
            else
            {
                if (!HikPlayer.PlayM4_GetJPEG(nPort, pImage, nBufSize, out pImageSize))
                    return;

                if (strCapPicPath.Length < 0)
                    strCapPicPath = Application.StartupPath;

                sFilePath = string.Format(@"{0}\capture{1:00}.jpeg", strCapPicPath, nJpeg);
                nJpeg++;
            }

            if (pImageSize > 0)
            {
                try
                {
                    FileStream fs = new FileStream(sFilePath, FileMode.CreateNew);
                    //ʼд 
                    fs.Write(pImage, 0, pImageSize);
                    //ջر 
                    fs.Flush();
                    fs.Close();
                }
                catch (System.Exception e)
                {
                    throw e;
                }
            }
        }

        private void Sound()
        {
            if (bSound)
            {
                if (HikPlayer.PlayM4_StopSound())
                {
                    bSound = false;
                    this.tsbtnVolume.Image = NHikPlayer.Properties.Resources.VolumeN;
                }
            }
            else
            {
                if (HikPlayer.PlayM4_PlaySound(nPort))
                {
                    bSound = true;
                    this.tsbtnVolume.Image = NHikPlayer.Properties.Resources.Volume;
                }
            }
        }



        private void PlayOrPause()
        {
            if (!bOpen)
                return;

            if (enumState == VIDEO_PLAY_STATE.State_Play)
            {
                Pause();
                this.tsslblStatus.Text = "ͣ";
                this.tsbtnPlayOrPause.Image = global::NHikPlayer.Properties.Resources.Play;
            }
            else if (enumState == VIDEO_PLAY_STATE.State_Pause ||
                enumState == VIDEO_PLAY_STATE.State_Stop ||
                enumState == VIDEO_PLAY_STATE.State_Close)
            {
                Play();
                this.tsslblStatus.Text = "";
                this.tsbtnPlayOrPause.Image = global::NHikPlayer.Properties.Resources.Pause;
            }
        }

        private void Open()
        {
            Close();
            try
            {
                OpenFile();
                bOpen = true;
                HikPlayer.PlayM4_SetPicQuality(nPort, bPicQuality);
                HikPlayer.PlayM4_SetDeflash(nPort, bDeflash);
                //CPUٶȽϿ죬ôһ֡ûţִPlayM4_GetPictureSizeᵼ»ȡƵСʧܡ
                System.Threading.Thread.Sleep(100);
                HikPlayer.PlayM4_GetPictureSize(nPort, out nWidth, out nHeight);

                // Ƶʽ HCIF, ô߶Ҫ2
                if ((nWidth == HikPlayer.WIDTH_PAL * 2) && (nHeight <= HikPlayer.HEIGHT_PAL))
                    nHeight *= 2;

                InitWindowSize(100);
            }
            catch
            {
                Close();
            }
        }

        private new void Close()
        {
            if (bOpen)
            {
                CloseFile();
            }
        }

        private void SetControlsVisibility(bool value)
        {
            this.menuItemFile.Visible = value;
            this.menuItemView.Visible = value;
            this.menuItemControl.Visible = value;
            this.menuItemOption.Visible = value;
            this.menuItemHelp.Visible = value;

            this.toolStrip1.Visible = value;
            this.statusStrip1.Visible = value;
        }

        private void ViewFullScreen()
        {
            bFullScreen = !bFullScreen;
            if (bFullScreen)
            {
                this.FormBorderStyle = FormBorderStyle.None;
                this.WindowState = FormWindowState.Maximized;
                this.TopMost = true;

                SetControlsVisibility(false);
            }
            else
            {
                this.FormBorderStyle = FormBorderStyle.Sizable;
                this.WindowState = FormWindowState.Normal;
                this.TopMost = this.menuItemTopMostAlways.Checked ? true : false;

                SetControlsVisibility(true);
            }
            this.pInfo.Left = (this.pVideo.Width - this.pInfo.Width) / 2;
            this.pInfo.Top = (this.pVideo.Height - this.pInfo.Height) / 2;
            HikPlayer.PlayM4_RefreshPlay(nPort);
        }

        private void ViewZoom(int nItem)
        {
            if (bFullScreen)
            {
                ViewFullScreen();
            }

            switch (nItem)
            {
                case 50:
                    InitWindowSize(50);
                    break;
                case 200:
                    InitWindowSize(200);
                    break;
                case 100:
                default:
                    InitWindowSize(100);
                    break;
            }
        }

        private bool SetDevice(int nDeviceSeq)
        {
            bool isDone = false;
            if (HikPlayer.WINVER > 0x0400)
            {
                if (HikPlayer.PlayM4_GetDDrawDeviceTotalNums() >= 1)
                {
                    for (int i = 0; i < HikPlayer.MAX_DISPLAY_DEVICE; i++)
                    {
                        this.menuItemDevice.MenuItems[i].Checked = false;
                    }

                    if (HikPlayer.PlayM4_SetDDrawDevice(nPort, nDeviceSeq))
                    {
                        this.menuItemDevice.MenuItems[nDeviceSeq].Checked = true;
                        isDone = true;
                    }
                }
            }
            return isDone;
        }

        private void Repeat()
        {
            bRepeatPlay = !bRepeatPlay;
            this.menuItemRepeatPlay.Checked = bRepeatPlay;
            this.tsbtnMode.Checked = bRepeatPlay;
        }

        private void ThrowBFrame(int iFrame)
        {
            HikPlayer.PlayM4_ThrowBFrameNum(nPort, iFrame);
        }

        #endregion

        #region 
        private void SetDisplayRegion(Rectangle pSrcRect, IntPtr hDestWnd)
        {
            if (enumState != VIDEO_PLAY_STATE.State_Pause)
            {
                return;
            }
            HikPlayer.PlayM4_SetDisplayRegion(nPort, 0, ref pSrcRect, hDestWnd, true);
            Win32API.UpdateWindow(this.Handle);
            HikPlayer.PlayM4_RefreshPlayEx(nPort, 0);
        }

        private void InitWindowSize(int p)
        {
            int width = nWidth;
            int height = nHeight;
            
            switch (p)
            {
                case 50:
                    width = nWidth / 2;
                    height = nHeight / 2;
            	    break;
                case 200:
                    width = nWidth * 2;
                    height = nHeight * 2;
            	    break;
            }

            //Spy++pVideoؼ8px,116px
            this.Width = width + 8;
            this.Height = height + 116;

            this.pVideo.Width = width;
            this.pVideo.Height = height;

            //ʾ
            this.Left = (Screen.PrimaryScreen.Bounds.Width - this.Width) / 2;
            this.Top = (Screen.PrimaryScreen.Bounds.Height - this.Height) / 2;
        }

        private void UpdateStatus()
        {
            int nCurrentTime = HikPlayer.PlayM4_GetPlayedTime(nPort);
            int nCurrentFrame = HikPlayer.PlayM4_GetCurrentFrameNum(nPort);

            int nScrollPos = nCurrentFrame * HikPlayer.PLAYER_SLIDER_MAX / (dwTotalFrames - 1);
            if (nPrePlayPos == nScrollPos)
                return;
            nPrePlayPos = nScrollPos;

            this.cSliderTime.Value = nScrollPos;
            this.cSliderTime.Refresh();

            this.tsslblFrame.Text = string.Format("֡{0,5} / {1,5}", nCurrentFrame+1, dwTotalFrames);
            this.tsslblTime.Text = string.Format("ʱ䣺{0} / {1}", FormatTimeStatus(nCurrentTime), FormatTimeStatus(dwMaxFileTime));

            if (nCurrentFrame+1 == dwTotalFrames)
            {
                //ֹͣ
                HikPlayer.PlayM4_SetFileEndMsg(nPort, pVideo.Handle, 0);
                bSound = HikPlayer.PlayM4_StopSound();
                HikPlayer.PlayM4_Stop(nPort);
                enumState = VIDEO_PLAY_STATE.State_Stop;

                this.timer1.Enabled = false;
                this.tsbtnPlayOrPause.Image = global::NHikPlayer.Properties.Resources.Play;
                this.tsslblStatus.Text = "ֹͣ";
            }
        }

        private string FormatSpeedStatus()
        {
            string dwValue = "ٶ";
            switch (nSpeed)
            {
                case 1:
                    dwValue += " X2"; break;
                case 2:
                    dwValue += " X4"; break;
                case 3:
                    dwValue += " X8"; break;
                case 4:
                    dwValue += " X16"; break;
                case -1:
                    dwValue += " /2"; break;
                case -2:
                    dwValue += " /4"; break;
                case -3:
                    dwValue += " /8"; break;
                case -4:
                    dwValue += " /16"; break;
                case 0:
                default:
                    dwValue += " X1"; break;
            }
            return dwValue;
        }

        private string FormatTimeStatus(int nSeconds)
        {
            int mHour = nSeconds / 3600;
            int mMinute = (nSeconds % 3600) / 60;
            int mSecond = nSeconds % 60;
            return string.Format("{0:00}:{1:00}:{2:00}", mHour, mMinute, mSecond);
        }

		#endregion

		#region ¼

        #region FormMain
        private void FormMain_Load(object sender, System.EventArgs e)
		{
            this.pVideo.AllowDrop = true;

            enumState = VIDEO_PLAY_STATE.State_Close;

            // ץͼص
            dcbf = new DisplayCBFun(CB_DisplayCBFun);
            HikPlayer.PlayM4_SetDisplayCallBack(nPort, dcbf);
            GC.KeepAlive(dcbf);
            // Ƶص
            ad = new Audio(CB_Audio);
            HikPlayer.PlayM4_SetAudioCallBack(nPort, ad, 0);
            GC.KeepAlive(ad);

            this.cSliderTime.Minimum = 0;
            this.cSliderTime.Maximum = HikPlayer.PLAYER_SLIDER_MAX;
            this.cSliderTime.Value = 0;

            this.cSliderVolume.ColorSlider.Maximum = 0;
            this.cSliderVolume.ColorSlider.Maximum = 0xffff - 1;
            this.cSliderVolume.Value = this.cSliderVolume.ColorSlider.Maximum * 3 / 4;

            this.pInfo.Left = (this.pVideo.Width - this.pInfo.Width) / 2;
            this.pInfo.Top = (this.pVideo.Height - this.pInfo.Height) / 2;

            //
            HikPlayer.PlayM4_SetVolume(nPort, this.cSliderVolume.Value);

            string chDriverDesp = string.Empty;
            string chDriverName = string.Empty;
            IntPtr hMonitor = new IntPtr();
            HikPlayer.PlayM4_InitDDrawDevice();
            int nVal = HikPlayer.PlayM4_GetDDrawDeviceTotalNums();
            nVal = (nVal < HikPlayer.MAX_DISPLAY_DEVICE) ? nVal : HikPlayer.MAX_DISPLAY_DEVICE;
            for (int nCount = 1; nCount <= nVal; nCount++)
            {
                HikPlayer.PlayM4_GetDDrawDeviceInfo(nCount, chDriverDesp, 50, chDriverName, 50, hMonitor);

                MenuItem driverItem = new MenuItem(chDriverDesp);
                this.menuItemDevice.MenuItems.Add(driverItem);
            }
            if (this.menuItemDevice.MenuItems.Count > 0)
            {
                this.menuItemDevice.MenuItems[0].Checked = true;
            }

            HikPlayer.PlayM4_SetDDrawDevice(nPort, 0);
			HikPlayer.PlayM4_SetFileEndMsg(nPort, pVideo.Handle, HikPlayer.WM_FILE_END);
			HikPlayer.PlayM4_SetEncChangeMsg(nPort, pVideo.Handle, HikPlayer.WM_ENC_CHANGE);
        }

        private void FormMain_FormClosing(object sender, FormClosingEventArgs e)
        {
            HikPlayer.PlayM4_Stop(nPort);
            HikPlayer.PlayM4_CloseFile(nPort);
            HikPlayer.PlayM4_RealeseDDraw();

            if (HikPlayer.WINVER > 0x0400)
                HikPlayer.PlayM4_ReleaseDDrawDevice();
        }

        private void pVideo_MouseDown(object sender, MouseEventArgs e)
        {

        }

        private void pVideo_DragDrop(object sender, DragEventArgs e)
        {
            try
            {
                string[] files = e.Data.GetData(DataFormats.FileDrop) as String[];
                
                if (files.Length > 0)
                {
                    string strExtension = Path.GetExtension(files[0]).ToLower();
                    if (strExtension.Equals(".mp4") || strExtension.Equals(".264"))
                    {
                        strPlayFileName = files[0];
                        Open();
                    }
                }
            }
            catch (Exception e1)
            {
                MessageBox.Show(e1.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void pVideo_DragEnter(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.Move;
        }

        private void pVideo_SizeChanged(object sender, EventArgs e)
        {
            HikPlayer.PlayM4_GetPictureSize(nPort, out nWidth, out nHeight);
        }

        private void pVideo_DoubleClick(object sender, EventArgs e)
        {
            ViewFullScreen();
        }

        private void cSliderTime_Scroll(object sender, ScrollEventArgs e)
        {
            int nPlayPos = this.cSliderTime.Value;
            if (Math.Abs(nPlayPos - nPrePlayPos) < 3)
                return;

            if (bFileRefCreated)
            {
                HikPlayer.PlayM4_SetPlayPos(nPort, (float)nPlayPos / (float)HikPlayer.PLAYER_SLIDER_MAX);
            }
            else
            {
                int nTime = nPlayPos * 1000 / HikPlayer.PLAYER_SLIDER_MAX * dwMaxFileTime;
                HikPlayer.PlayM4_SetPlayedTimeEx(nPort, nTime);
            }

            UpdateStatus();
        }

        private void cSliderVolume_Scroll(object sender, ScrollEventArgs e)
        {
            HikPlayer.PlayM4_SetVolume(nPort, this.cSliderVolume.Value);
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            UpdateStatus();
        }
        #endregion

        #region MenuItemļ
        private void menuItemOpen_Click(object sender, System.EventArgs e)
        {
            if (BrowseFile())
            {
                Open();
                this.pInfo.Visible = false;
            }
        }

		private void menuItemClose_Click(object sender, System.EventArgs e)
		{
            Close();
            this.pInfo.Visible = true;
		}

		private void menuItemExit_Click(object sender, System.EventArgs e)
		{
            Close();
			Application.Exit();
		}
		#endregion

		#region MenuItemͼ
		
		private void menuItemFullscreen_Click(object sender, System.EventArgs e)
		{
            ViewFullScreen();
		}

		private void menuItem50p_Click(object sender, System.EventArgs e)
		{
            this.menuItem50p.Checked = true;
            this.menuItem100p.Checked = false;
            this.menuItem200p.Checked = false;
            ViewZoom(50);
		}

        private void menuItem100p_Click(object sender, System.EventArgs e)
        {
            this.menuItem50p.Checked = false;
            this.menuItem100p.Checked = true;
            this.menuItem200p.Checked = false;
            ViewZoom(100);
        }

		private void menuItem200p_Click(object sender, System.EventArgs e)
		{
            this.menuItem50p.Checked = false;
            this.menuItem100p.Checked = false;
            this.menuItem200p.Checked = true;
            ViewZoom(200);
		}

        private void menuItemInfo_Click(object sender, System.EventArgs e)
		{
            FormInfo frmInfo = new FormInfo(nPort);
            frmInfo.ShowDialog(this.Owner);
		}

		private void menuItemRegion_Click(object sender, System.EventArgs e)
		{
            FormRegion frmRegion = new FormRegion(nPort);
            frmRegion.ShowDialog(this.Owner);
		}

        private void menuItemTopMostNever_Click(object sender, EventArgs e)
        {
            this.menuItemTopMostNever.Checked = true;
            this.menuItemTopMostAlways.Checked = false;
            this.TopMost = false;
        }

        private void menuItemTopMostAlways_Click(object sender, EventArgs e)
        {
            this.menuItemTopMostNever.Checked = false;
            this.menuItemTopMostAlways.Checked = true;
            this.TopMost = true;
        }
		#endregion

		#region MenuItem
		private void menuItemPlayOrPause_Click(object sender, System.EventArgs e)
		{
            PlayOrPause();
		}

		private void menuItemStop_Click(object sender, System.EventArgs e)
		{
            this.pInfo.Visible = true;

            if (enumState != VIDEO_PLAY_STATE.State_Close)
            {
                Stop();
            }
        }

        private void menuItemStepForward_Click(object sender, EventArgs e)
        {
            if (enumState != VIDEO_PLAY_STATE.State_Stop)
            {
                StepForward();
            }
        }

        private void menuItemStepBackward_Click(object sender, EventArgs e)
        {
            if (enumState != VIDEO_PLAY_STATE.State_Stop)
            {
                StepBackward();
            }
        }

		private void menuItemFirst_Click(object sender, System.EventArgs e)
		{
            GotoStart();
		}

		private void menuItemLast_Click(object sender, System.EventArgs e)
		{
            GotoEnd();
		}

		private void menuItemLocation_Click(object sender, System.EventArgs e)
		{
            FormLocation frmLocation = new FormLocation(nPort, bFileRefCreated);
            Point startPoint = new Point(this.Left + this.Width, this.Top);
            frmLocation.StartPosition = FormStartPosition.Manual;
            frmLocation.Location = startPoint;
            frmLocation.ShowDialog(this.Owner);
		}

		private void menuItemSetting_Click(object sender, System.EventArgs e)
		{
            FormSetting frmSetting = new FormSetting(nPort);
            Point startPoint = new Point(this.Left + this.Width, this.Top);
            frmSetting.StartPosition = FormStartPosition.Manual;
            frmSetting.Location = startPoint;
            frmSetting.ShowDialog(this.Owner);
		}

        private void menuItemRepeatPlay_Click(object sender, EventArgs e)
        {
            Repeat();
        }
		#endregion

        #region MenuItemѡ
        private void menuItemBMP_Click(object sender, System.EventArgs e)
        {
            this.menuItemBMP.Checked = true;
            this.menuItemJPG.Checked = false;
            nCapPicType = 0;
        }

        private void menuItemJPG_Click(object sender, System.EventArgs e)
        {
            this.menuItemBMP.Checked = false;
            this.menuItemJPG.Checked = true;
            nCapPicType = 1;
        }

        private void menuItemSavePath_Click(object sender, System.EventArgs e)
        {
            FolderBrowserDialog fdBwerDlg = new FolderBrowserDialog();
            fdBwerDlg.Description = "ѡ񱣴ͼƬļ";
            fdBwerDlg.ShowNewFolderButton = true;
            if (strCapPicPath.Length > 0)
                fdBwerDlg.SelectedPath = strCapPicPath;
            else
                fdBwerDlg.SelectedPath = Application.StartupPath;

            if (fdBwerDlg.ShowDialog() == DialogResult.OK)
            {
                strCapPicPath = fdBwerDlg.SelectedPath;
            }
        }

        private void menuItemDeflash_Click(object sender, EventArgs e)
        {
            bDeflash = !bDeflash;
            HikPlayer.PlayM4_SetDeflash(nPort, bDeflash);
            this.menuItemDeflash.Checked = bDeflash;
        }

        private void menuItemHighQuality_Click(object sender, System.EventArgs e)
        {
            bPicQuality = !bPicQuality;
            HikPlayer.PlayM4_SetPicQuality(nPort, bPicQuality);
            this.menuItemHighQuality.Checked = bPicQuality;
        }

        private void menuItemThrowBFrame0_Click(object sender, EventArgs e)
        {
            ThrowBFrame(0);
            this.menuItemThrowBFrame0.Checked = true;
            this.menuItemThrowBFrame1.Checked = false;
            this.menuItemThrowBFrame2.Checked = false;
        }

        private void menuItemThrowBFrame1_Click(object sender, EventArgs e)
        {
            ThrowBFrame(1);
            this.menuItemThrowBFrame0.Checked = false;
            this.menuItemThrowBFrame1.Checked = true;
            this.menuItemThrowBFrame2.Checked = false;
        }

        private void menuItemThrowBFrame2_Click(object sender, EventArgs e)
        {
            ThrowBFrame(2);
            this.menuItemThrowBFrame0.Checked = false;
            this.menuItemThrowBFrame1.Checked = false;
            this.menuItemThrowBFrame2.Checked = true;
        }

        private void menuItemDisplayNormal_Click(object sender, System.EventArgs e)
        {
            HikPlayer.PlayM4_SetDisplayType(nPort, HikPlayer.DISPLAY_NORMAL);
            this.menuItemDisplayNormal.Checked = true;
            this.menuItemDisplayQuarter.Checked = false;
        }

        private void menuItemDisplayQuarter_Click(object sender, EventArgs e)
        {
            HikPlayer.PlayM4_SetDisplayType(nPort, HikPlayer.DISPLAY_QUARTER);
            this.menuItemDisplayNormal.Checked = false;
            this.menuItemDisplayQuarter.Checked = true;
        }

        private void menuItemTimer_1_Click(object sender, System.EventArgs e)
        {
            HikPlayer.PlayM4_SetTimerType(nPort, HikPlayer.TIMER_1, 0);
            this.menuItemTimer_1.Checked = true;
            this.menuItemTimer_2.Checked = false;
        }

        private void menuItemTimer_2_Click(object sender, System.EventArgs e)
        {
            HikPlayer.PlayM4_SetTimerType(nPort, HikPlayer.TIMER_2, 0);
            this.menuItemTimer_1.Checked = false;
            this.menuItemTimer_2.Checked = true;
        }

        private void menuItemResetBuffer_Click(object sender, System.EventArgs e)
        {
            HikPlayer.PlayM4_ResetBuffer(nPort, HikPlayer.BUF_VIDEO_RENDER);
            HikPlayer.PlayM4_ResetBuffer(nPort, HikPlayer.BUF_AUDIO_RENDER);
            HikPlayer.PlayM4_ResetBuffer(nPort, HikPlayer.BUF_VIDEO_SRC);
            HikPlayer.PlayM4_ResetBuffer(nPort, HikPlayer.BUF_AUDIO_SRC);
        }
        #endregion

		#region MenuItem
		private void menuItemManual_Click(object sender, System.EventArgs e)
		{
            FormHelp frmHelp = new FormHelp();
            frmHelp.ShowDialog(this.Owner);
		}

		private void menuItemAbout_Click(object sender, System.EventArgs e)
		{
            FormAbout frmAbout = new FormAbout();
            frmAbout.ShowDialog(this.Owner);
		}
		#endregion

        #region ToolStrip

        private void tsbtnOpen_Click(object sender, EventArgs e)
        {
            if (BrowseFile())
            {
                Open();
            }
        }

        private void tsbtnPlayOrPause_Click(object sender, EventArgs e)
        {
            PlayOrPause();
        }

        private void tsbtnStop_Click(object sender, EventArgs e)
        {
            Stop();
        }

        private void tsbtnSlow_Click(object sender, EventArgs e)
        {
            Play();
            Slow();
            this.tsslblSpeed.Text = FormatSpeedStatus();
        }

        private void tsbtnRestoreSpeed_Click(object sender, EventArgs e)
        {
            RestoreSpeed();
            this.tsslblSpeed.Text = FormatSpeedStatus();
        }

        private void tsbtnFast_Click(object sender, EventArgs e)
        {
            Play();
            Fast();
            this.tsslblSpeed.Text = FormatSpeedStatus();
        }

        private void tsbtnStepBackward_Click(object sender, EventArgs e)
        {
            StepBackward();
        }

        private void tsbtnStepForward_Click(object sender, EventArgs e)
        {
            StepForward();
        }

        private void tsbtnMode_Click(object sender, EventArgs e)
        {
            Repeat();
        }

        private void tsbtnFullscreen_Click(object sender, EventArgs e)
        {
            ViewFullScreen();
        }

        private void tsbtnCappic_Click(object sender, EventArgs e)
        {
            Cappic();
        }

        private void tsbtnVolume_Click(object sender, EventArgs e)
        {
            Sound();
        }
        #endregion

        #endregion
    }
}
