﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Reflection;
using System.Windows.Forms;

namespace NHikPlayer
{
    partial class FormRegion : Form
    {
        private Label lblTitle;
        private Button btnOk;
        private Line line;
        private Panel pRegion;
        private Label lblZoom;
        private NumericTextBox ntbRegion;
        private Label lblPercent;
        private TrackBar trbRegion;
        private Button btnReset;
        private PictureBox picbZoomOut;
        private PictureBox picbZoomIn;
        
        private int nPort = 0;
        private Button btnRegion;
        //private Rectangle CatchRect; //表示显示区域的矩形

        /// <summary>
        /// 必需的设计器变量。
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        /// <summary>
        /// 清理所有正在使用的资源。
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        #region Windows 窗体设计器生成的代码

        /// <summary>
        /// 设计器支持所需的方法 - 不要
        /// 使用代码编辑器修改此方法的内容。
        /// </summary>
        private void InitializeComponent()
        {
            this.lblTitle = new System.Windows.Forms.Label();
            this.btnOk = new System.Windows.Forms.Button();
            this.pRegion = new System.Windows.Forms.Panel();
            this.lblZoom = new System.Windows.Forms.Label();
            this.lblPercent = new System.Windows.Forms.Label();
            this.trbRegion = new System.Windows.Forms.TrackBar();
            this.btnReset = new System.Windows.Forms.Button();
            this.picbZoomOut = new System.Windows.Forms.PictureBox();
            this.picbZoomIn = new System.Windows.Forms.PictureBox();
            this.ntbRegion = new NHikPlayer.NumericTextBox();
            this.line = new NHikPlayer.Line();
            this.btnRegion = new System.Windows.Forms.Button();
            ((System.ComponentModel.ISupportInitialize)(this.trbRegion)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.picbZoomOut)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.picbZoomIn)).BeginInit();
            this.SuspendLayout();
            // 
            // lblTitle
            // 
            this.lblTitle.AutoSize = true;
            this.lblTitle.Font = new System.Drawing.Font("黑体", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(134)));
            this.lblTitle.ForeColor = System.Drawing.Color.SteelBlue;
            this.lblTitle.Location = new System.Drawing.Point(114, 12);
            this.lblTitle.Name = "lblTitle";
            this.lblTitle.Size = new System.Drawing.Size(144, 16);
            this.lblTitle.TabIndex = 0;
            this.lblTitle.Text = "视频画面区域显示";
            // 
            // btnOk
            // 
            this.btnOk.Location = new System.Drawing.Point(261, 323);
            this.btnOk.Name = "btnOk";
            this.btnOk.Size = new System.Drawing.Size(75, 23);
            this.btnOk.TabIndex = 7;
            this.btnOk.Text = "确定";
            this.btnOk.UseVisualStyleBackColor = true;
            this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
            // 
            // pRegion
            // 
            this.pRegion.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.pRegion.Location = new System.Drawing.Point(12, 53);
            this.pRegion.Name = "pRegion";
            this.pRegion.Size = new System.Drawing.Size(350, 226);
            this.pRegion.TabIndex = 2;
            // 
            // lblZoom
            // 
            this.lblZoom.AutoSize = true;
            this.lblZoom.Location = new System.Drawing.Point(13, 298);
            this.lblZoom.Name = "lblZoom";
            this.lblZoom.Size = new System.Drawing.Size(41, 12);
            this.lblZoom.TabIndex = 3;
            this.lblZoom.Text = "缩放：";
            // 
            // lblPercent
            // 
            this.lblPercent.AutoSize = true;
            this.lblPercent.Location = new System.Drawing.Point(107, 298);
            this.lblPercent.Name = "lblPercent";
            this.lblPercent.Size = new System.Drawing.Size(11, 12);
            this.lblPercent.TabIndex = 5;
            this.lblPercent.Text = "%";
            // 
            // trbRegion
            // 
            this.trbRegion.AutoSize = false;
            this.trbRegion.Location = new System.Drawing.Point(154, 292);
            this.trbRegion.Maximum = 1100;
            this.trbRegion.Minimum = 100;
            this.trbRegion.Name = "trbRegion";
            this.trbRegion.Size = new System.Drawing.Size(139, 23);
            this.trbRegion.TabIndex = 6;
            this.trbRegion.TickStyle = System.Windows.Forms.TickStyle.None;
            this.trbRegion.Value = 100;
            this.trbRegion.Scroll += new System.EventHandler(this.trbRegion_Scroll);
            // 
            // btnReset
            // 
            this.btnReset.Location = new System.Drawing.Point(132, 323);
            this.btnReset.Name = "btnReset";
            this.btnReset.Size = new System.Drawing.Size(75, 23);
            this.btnReset.TabIndex = 8;
            this.btnReset.Text = "默认值";
            this.btnReset.UseVisualStyleBackColor = true;
            this.btnReset.Click += new System.EventHandler(this.btnReset_Click);
            // 
            // picbZoomOut
            // 
            this.picbZoomOut.Image = global::NHikPlayer.Properties.Resources.ZoomOut;
            this.picbZoomOut.Location = new System.Drawing.Point(132, 296);
            this.picbZoomOut.Name = "picbZoomOut";
            this.picbZoomOut.Size = new System.Drawing.Size(16, 16);
            this.picbZoomOut.TabIndex = 17;
            this.picbZoomOut.TabStop = false;
            this.picbZoomOut.Click += new System.EventHandler(this.picbZoomOut_Click);
            // 
            // picbZoomIn
            // 
            this.picbZoomIn.Image = global::NHikPlayer.Properties.Resources.ZoomIn;
            this.picbZoomIn.Location = new System.Drawing.Point(299, 296);
            this.picbZoomIn.Name = "picbZoomIn";
            this.picbZoomIn.Size = new System.Drawing.Size(16, 16);
            this.picbZoomIn.TabIndex = 18;
            this.picbZoomIn.TabStop = false;
            this.picbZoomIn.Click += new System.EventHandler(this.picbZoomIn_Click);
            // 
            // ntbRegion
            // 
            this.ntbRegion.AllowSpace = false;
            this.ntbRegion.Location = new System.Drawing.Point(49, 294);
            this.ntbRegion.MaxLength = 4;
            this.ntbRegion.Name = "ntbRegion";
            this.ntbRegion.Size = new System.Drawing.Size(56, 21);
            this.ntbRegion.TabIndex = 4;
            this.ntbRegion.Text = "100";
            // 
            // line
            // 
            this.line.Location = new System.Drawing.Point(12, 37);
            this.line.Name = "line";
            this.line.Size = new System.Drawing.Size(350, 10);
            this.line.TabIndex = 1;
            this.line.Text = "line1";
            // 
            // btnRegion
            // 
            this.btnRegion.Location = new System.Drawing.Point(30, 323);
            this.btnRegion.Name = "btnRegion";
            this.btnRegion.Size = new System.Drawing.Size(75, 23);
            this.btnRegion.TabIndex = 19;
            this.btnRegion.Text = "设置";
            this.btnRegion.UseVisualStyleBackColor = true;
            this.btnRegion.Click += new System.EventHandler(this.btnRegion_Click);
            // 
            // FormRegion
            // 
            this.AcceptButton = this.btnOk;
            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 12F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            this.ClientSize = new System.Drawing.Size(374, 363);
            this.Controls.Add(this.btnRegion);
            this.Controls.Add(this.picbZoomIn);
            this.Controls.Add(this.picbZoomOut);
            this.Controls.Add(this.btnReset);
            this.Controls.Add(this.trbRegion);
            this.Controls.Add(this.lblPercent);
            this.Controls.Add(this.ntbRegion);
            this.Controls.Add(this.lblZoom);
            this.Controls.Add(this.pRegion);
            this.Controls.Add(this.line);
            this.Controls.Add(this.btnOk);
            this.Controls.Add(this.lblTitle);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "FormRegion";
            this.Padding = new System.Windows.Forms.Padding(9, 8, 9, 8);
            this.ShowIcon = false;
            this.ShowInTaskbar = false;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "区域显示";
            this.Load += new System.EventHandler(this.FormRegion_Load);
            ((System.ComponentModel.ISupportInitialize)(this.trbRegion)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.picbZoomOut)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.picbZoomIn)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        #endregion

        public FormRegion(int Port)
        {
            InitializeComponent();
            nPort = Port;
        }

        private void FormRegion_Load(object sender, EventArgs e)
        {
            //设置控件样式为双缓冲，可以有效减少图片闪烁的问题
            this.SetStyle(ControlStyles.OptimizedDoubleBuffer | ControlStyles.AllPaintingInWmPaint | ControlStyles.UserPaint, true);
            this.UpdateStyles();
        }

        private void btnRegion_Click(object sender, EventArgs e)
        {
            if (this.ntbRegion.IntValue < 100)
            {
                this.ntbRegion.Text = "100";
                this.trbRegion.Value = 100;
            }
            else if (this.ntbRegion.IntValue > 1100)
            {
                this.ntbRegion.Text = "1100";
                this.trbRegion.Value = 1100;
            }
            else
            {
                this.trbRegion.Value = this.ntbRegion.IntValue;
            }
        }

        private void btnReset_Click(object sender, EventArgs e)
        {
            this.trbRegion.Value = 100;
            this.ntbRegion.Text = this.trbRegion.Value.ToString();
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void trbRegion_Scroll(object sender, EventArgs e)
        {
            this.ntbRegion.Text = this.trbRegion.Value.ToString();
        }

        private void picbZoomOut_Click(object sender, EventArgs e)
        {
            if (this.trbRegion.Value >= 200)
                this.trbRegion.Value -= 100;
            else
                this.trbRegion.Value = 100;

            this.ntbRegion.Text = this.trbRegion.Value.ToString();
        }

        private void picbZoomIn_Click(object sender, EventArgs e)
        {
            if (this.trbRegion.Value <= 1000)
                this.trbRegion.Value += 100;
            else
                this.trbRegion.Value = 1100;

            this.ntbRegion.Text = this.trbRegion.Value.ToString();
        }
    }
}
