﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Reflection;
using System.Windows.Forms;

namespace NHikPlayer
{
    partial class FormSetting : Form
    {
        private Label lblTitle;
        private Button btnOk;
        private Line line;
        private GroupBox grbSetting;
        private Button btnReset;
        private Label lblSaturation;
        private Label lblHue;
        private Label lblContrast;
        private Label lblBrightness;
        private PictureBox picbSaturation;
        private PictureBox picbHue;
        private PictureBox picbContrast;
        private PictureBox picbBrightness;
        private TrackBar trbBrightness;
        private TrackBar trbSaturation;
        private TrackBar trbHue;
        private TrackBar trbContrast;

        private int nPort = 0;

        /// <summary>
        /// 必需的设计器变量。
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        /// <summary>
        /// 清理所有正在使用的资源。
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        #region Windows 窗体设计器生成的代码

        /// <summary>
        /// 设计器支持所需的方法 - 不要
        /// 使用代码编辑器修改此方法的内容。
        /// </summary>
        private void InitializeComponent()
        {
            this.lblTitle = new System.Windows.Forms.Label();
            this.btnOk = new System.Windows.Forms.Button();
            this.grbSetting = new System.Windows.Forms.GroupBox();
            this.trbSaturation = new System.Windows.Forms.TrackBar();
            this.trbHue = new System.Windows.Forms.TrackBar();
            this.trbContrast = new System.Windows.Forms.TrackBar();
            this.trbBrightness = new System.Windows.Forms.TrackBar();
            this.picbSaturation = new System.Windows.Forms.PictureBox();
            this.picbHue = new System.Windows.Forms.PictureBox();
            this.picbContrast = new System.Windows.Forms.PictureBox();
            this.picbBrightness = new System.Windows.Forms.PictureBox();
            this.lblSaturation = new System.Windows.Forms.Label();
            this.lblHue = new System.Windows.Forms.Label();
            this.lblContrast = new System.Windows.Forms.Label();
            this.lblBrightness = new System.Windows.Forms.Label();
            this.btnReset = new System.Windows.Forms.Button();
            this.line = new NHikPlayer.Line();
            this.grbSetting.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.trbSaturation)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.trbHue)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.trbContrast)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.trbBrightness)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.picbSaturation)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.picbHue)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.picbContrast)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.picbBrightness)).BeginInit();
            this.SuspendLayout();
            // 
            // lblTitle
            // 
            this.lblTitle.AutoSize = true;
            this.lblTitle.Font = new System.Drawing.Font("黑体", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(134)));
            this.lblTitle.ForeColor = System.Drawing.Color.SteelBlue;
            this.lblTitle.Location = new System.Drawing.Point(114, 12);
            this.lblTitle.Name = "lblTitle";
            this.lblTitle.Size = new System.Drawing.Size(144, 16);
            this.lblTitle.TabIndex = 0;
            this.lblTitle.Text = "视频画面显示控制";
            // 
            // btnOk
            // 
            this.btnOk.Location = new System.Drawing.Point(257, 277);
            this.btnOk.Name = "btnOk";
            this.btnOk.Size = new System.Drawing.Size(75, 23);
            this.btnOk.TabIndex = 5;
            this.btnOk.Text = "关闭";
            this.btnOk.UseVisualStyleBackColor = true;
            this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
            // 
            // grbSetting
            // 
            this.grbSetting.Controls.Add(this.trbSaturation);
            this.grbSetting.Controls.Add(this.trbHue);
            this.grbSetting.Controls.Add(this.trbContrast);
            this.grbSetting.Controls.Add(this.trbBrightness);
            this.grbSetting.Controls.Add(this.picbSaturation);
            this.grbSetting.Controls.Add(this.picbHue);
            this.grbSetting.Controls.Add(this.picbContrast);
            this.grbSetting.Controls.Add(this.picbBrightness);
            this.grbSetting.Controls.Add(this.lblSaturation);
            this.grbSetting.Controls.Add(this.lblHue);
            this.grbSetting.Controls.Add(this.lblContrast);
            this.grbSetting.Controls.Add(this.lblBrightness);
            this.grbSetting.Location = new System.Drawing.Point(24, 52);
            this.grbSetting.Name = "grbSetting";
            this.grbSetting.Size = new System.Drawing.Size(324, 211);
            this.grbSetting.TabIndex = 2;
            this.grbSetting.TabStop = false;
            this.grbSetting.Text = "定位范围";
            // 
            // trbSaturation
            // 
            this.trbSaturation.AutoSize = false;
            this.trbSaturation.Location = new System.Drawing.Point(244, 55);
            this.trbSaturation.Maximum = 128;
            this.trbSaturation.Name = "trbSaturation";
            this.trbSaturation.Orientation = System.Windows.Forms.Orientation.Vertical;
            this.trbSaturation.Size = new System.Drawing.Size(25, 143);
            this.trbSaturation.TabIndex = 15;
            this.trbSaturation.TickStyle = System.Windows.Forms.TickStyle.None;
            this.trbSaturation.Scroll += new System.EventHandler(this.trackBar_Scroll);
            // 
            // trbHue
            // 
            this.trbHue.AutoSize = false;
            this.trbHue.Location = new System.Drawing.Point(173, 55);
            this.trbHue.Maximum = 128;
            this.trbHue.Name = "trbHue";
            this.trbHue.Orientation = System.Windows.Forms.Orientation.Vertical;
            this.trbHue.Size = new System.Drawing.Size(25, 143);
            this.trbHue.TabIndex = 14;
            this.trbHue.TickStyle = System.Windows.Forms.TickStyle.None;
            this.trbHue.Scroll += new System.EventHandler(this.trackBar_Scroll);
            // 
            // trbContrast
            // 
            this.trbContrast.AutoSize = false;
            this.trbContrast.Location = new System.Drawing.Point(102, 55);
            this.trbContrast.Maximum = 128;
            this.trbContrast.Name = "trbContrast";
            this.trbContrast.Orientation = System.Windows.Forms.Orientation.Vertical;
            this.trbContrast.Size = new System.Drawing.Size(25, 143);
            this.trbContrast.TabIndex = 13;
            this.trbContrast.TickStyle = System.Windows.Forms.TickStyle.None;
            this.trbContrast.Scroll += new System.EventHandler(this.trackBar_Scroll);
            // 
            // trbBrightness
            // 
            this.trbBrightness.AutoSize = false;
            this.trbBrightness.Location = new System.Drawing.Point(31, 55);
            this.trbBrightness.Maximum = 128;
            this.trbBrightness.Name = "trbBrightness";
            this.trbBrightness.Orientation = System.Windows.Forms.Orientation.Vertical;
            this.trbBrightness.Size = new System.Drawing.Size(25, 143);
            this.trbBrightness.TabIndex = 12;
            this.trbBrightness.TickStyle = System.Windows.Forms.TickStyle.None;
            this.trbBrightness.Scroll += new System.EventHandler(this.trackBar_Scroll);
            // 
            // picbSaturation
            // 
            this.picbSaturation.Image = global::NHikPlayer.Properties.Resources.Saturation;
            this.picbSaturation.Location = new System.Drawing.Point(248, 29);
            this.picbSaturation.Name = "picbSaturation";
            this.picbSaturation.Size = new System.Drawing.Size(16, 16);
            this.picbSaturation.TabIndex = 11;
            this.picbSaturation.TabStop = false;
            // 
            // picbHue
            // 
            this.picbHue.Image = global::NHikPlayer.Properties.Resources.Hue;
            this.picbHue.Location = new System.Drawing.Point(177, 29);
            this.picbHue.Name = "picbHue";
            this.picbHue.Size = new System.Drawing.Size(16, 16);
            this.picbHue.TabIndex = 10;
            this.picbHue.TabStop = false;
            // 
            // picbContrast
            // 
            this.picbContrast.Image = global::NHikPlayer.Properties.Resources.Contrast;
            this.picbContrast.Location = new System.Drawing.Point(106, 29);
            this.picbContrast.Name = "picbContrast";
            this.picbContrast.Size = new System.Drawing.Size(16, 16);
            this.picbContrast.TabIndex = 9;
            this.picbContrast.TabStop = false;
            // 
            // picbBrightness
            // 
            this.picbBrightness.Image = global::NHikPlayer.Properties.Resources.Brightness;
            this.picbBrightness.Location = new System.Drawing.Point(35, 29);
            this.picbBrightness.Name = "picbBrightness";
            this.picbBrightness.Size = new System.Drawing.Size(16, 16);
            this.picbBrightness.TabIndex = 8;
            this.picbBrightness.TabStop = false;
            // 
            // lblSaturation
            // 
            this.lblSaturation.AutoSize = true;
            this.lblSaturation.Location = new System.Drawing.Point(268, 31);
            this.lblSaturation.Name = "lblSaturation";
            this.lblSaturation.Size = new System.Drawing.Size(41, 12);
            this.lblSaturation.TabIndex = 3;
            this.lblSaturation.Text = "饱和度";
            // 
            // lblHue
            // 
            this.lblHue.AutoSize = true;
            this.lblHue.Location = new System.Drawing.Point(197, 31);
            this.lblHue.Name = "lblHue";
            this.lblHue.Size = new System.Drawing.Size(29, 12);
            this.lblHue.TabIndex = 2;
            this.lblHue.Text = "色调";
            // 
            // lblContrast
            // 
            this.lblContrast.AutoSize = true;
            this.lblContrast.Location = new System.Drawing.Point(126, 31);
            this.lblContrast.Name = "lblContrast";
            this.lblContrast.Size = new System.Drawing.Size(41, 12);
            this.lblContrast.TabIndex = 1;
            this.lblContrast.Text = "对比度";
            // 
            // lblBrightness
            // 
            this.lblBrightness.AutoSize = true;
            this.lblBrightness.Location = new System.Drawing.Point(55, 31);
            this.lblBrightness.Name = "lblBrightness";
            this.lblBrightness.Size = new System.Drawing.Size(29, 12);
            this.lblBrightness.TabIndex = 0;
            this.lblBrightness.Text = "亮度";
            // 
            // btnReset
            // 
            this.btnReset.Location = new System.Drawing.Point(134, 277);
            this.btnReset.Name = "btnReset";
            this.btnReset.Size = new System.Drawing.Size(75, 23);
            this.btnReset.TabIndex = 4;
            this.btnReset.Text = "默认值";
            this.btnReset.UseVisualStyleBackColor = true;
            this.btnReset.Click += new System.EventHandler(this.btnReset_Click);
            // 
            // line
            // 
            this.line.Location = new System.Drawing.Point(12, 37);
            this.line.Name = "line";
            this.line.Size = new System.Drawing.Size(350, 10);
            this.line.TabIndex = 1;
            this.line.Text = "line1";
            // 
            // FormSetting
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 12F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            this.ClientSize = new System.Drawing.Size(374, 313);
            this.Controls.Add(this.btnReset);
            this.Controls.Add(this.grbSetting);
            this.Controls.Add(this.line);
            this.Controls.Add(this.btnOk);
            this.Controls.Add(this.lblTitle);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "FormSetting";
            this.Padding = new System.Windows.Forms.Padding(9, 8, 9, 8);
            this.ShowIcon = false;
            this.ShowInTaskbar = false;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "显示控制";
            this.Load += new System.EventHandler(this.FormSetting_Load);
            this.grbSetting.ResumeLayout(false);
            this.grbSetting.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.trbSaturation)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.trbHue)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.trbContrast)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.trbBrightness)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.picbSaturation)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.picbHue)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.picbContrast)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.picbBrightness)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        #endregion

        public FormSetting(int Port)
        {
            InitializeComponent();
            nPort = Port;
        }

        private void FormSetting_Load(object sender, EventArgs e)
        {
            this.trbBrightness.Value = HikPlayer.COLOR_DEFAULT;
            this.trbContrast.Value = HikPlayer.COLOR_DEFAULT;
            this.trbSaturation.Value = HikPlayer.COLOR_DEFAULT;
            this.trbHue.Value = HikPlayer.COLOR_DEFAULT;
        }

        private void trackBar_Scroll(object sender, EventArgs e)
        {
            int nBrightness = this.trbBrightness.Value;
            int nContrast = this.trbContrast.Value;
            int nSaturation = this.trbSaturation.Value;
            int nHue = this.trbHue.Value;

            HikPlayer.PlayM4_SetColor(nPort, 0, nBrightness, nContrast, nSaturation, nHue);
        }

        private void btnReset_Click(object sender, EventArgs e)
        {
            this.trbBrightness.Value = HikPlayer.COLOR_DEFAULT;
            this.trbContrast.Value = HikPlayer.COLOR_DEFAULT;
            this.trbSaturation.Value = HikPlayer.COLOR_DEFAULT;
            this.trbHue.Value = HikPlayer.COLOR_DEFAULT;

            HikPlayer.PlayM4_SetColor(nPort, 0,
                HikPlayer.COLOR_DEFAULT,
                HikPlayer.COLOR_DEFAULT,
                HikPlayer.COLOR_DEFAULT,
                HikPlayer.COLOR_DEFAULT);
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
